(function () {

/* Imports */
var Meteor = Package.meteor.Meteor;
var global = Package.meteor.global;
var meteorEnv = Package.meteor.meteorEnv;
var ECMAScript = Package.ecmascript.ECMAScript;
var MongoInternals = Package.mongo.MongoInternals;
var Mongo = Package.mongo.Mongo;
var Random = Package.random.Random;
var check = Package.check.check;
var Match = Package.check.Match;
var _ = Package.underscore._;
var Accounts = Package['accounts-base'].Accounts;
var HTTP = Package.http.HTTP;
var HTTPInternals = Package.http.HTTPInternals;
var Identicon = Package['sandstorm-identicons'].Identicon;
var meteorInstall = Package.modules.meteorInstall;
var Buffer = Package.modules.Buffer;
var process = Package.modules.process;
var Symbol = Package['ecmascript-runtime'].Symbol;
var Map = Package['ecmascript-runtime'].Map;
var Set = Package['ecmascript-runtime'].Set;
var meteorBabelHelpers = Package['babel-runtime'].meteorBabelHelpers;
var Promise = Package.promise.Promise;

/* Package-scope variables */
var Packages, DevPackages, UserActions, Grains, RoleAssignments, Contacts, Sessions, SignupKeys, ActivityStats, DeleteStats, FileTokens, ApiTokens, ApiHosts, Notifications, ActivitySubscriptions, StatsTokens, Misc, Settings, Migrations, StaticAssets, AssetUploadTokens, Plans, AppIndex, KeybaseProfiles, FeatureKey, SetupSession, successfulReferralsCount, isAdmin, isAdminById, findAdminUserForToken, matchWildcardHost, makeWildcardHost, getWildcardOrigin, SandstormDb, appName;

var require = meteorInstall({"node_modules":{"meteor":{"sandstorm-db":{"db.js":["babel-runtime/helpers/typeof",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/sandstorm-db/db.js                                                                                         //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _typeof;module.import("babel-runtime/helpers/typeof",{"default":function(v){_typeof=v}});                          //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
// This file defines the database schema.                                                                              //
                                                                                                                       //
// Useful for debugging: Set the env variable LOG_MONGO_QUERIES to have the server write every                         //
// query it makes, so you can see if it's doing queries too often, etc.                                                //
if (Meteor.isServer && process.env.LOG_MONGO_QUERIES) {                                                                // 21
  (function () {                                                                                                       // 21
    var oldFind = Mongo.Collection.prototype.find;                                                                     // 22
    Mongo.Collection.prototype.find = function () {                                                                    // 23
      console.log(this._prefix, arguments);                                                                            // 24
      return oldFind.apply(this, arguments);                                                                           // 25
    };                                                                                                                 // 26
  })();                                                                                                                // 21
}                                                                                                                      // 27
                                                                                                                       //
// Helper so that we don't have to if (Meteor.isServer) before declaring indexes.                                      //
if (Meteor.isServer) {                                                                                                 // 30
  Mongo.Collection.prototype.ensureIndexOnServer = Mongo.Collection.prototype._ensureIndex;                            // 31
} else {                                                                                                               // 32
  Mongo.Collection.prototype.ensureIndexOnServer = function () {};                                                     // 33
}                                                                                                                      // 34
                                                                                                                       //
// TODO(soon): Systematically go through this file and add ensureIndexOnServer() as needed.                            //
                                                                                                                       //
var collectionOptions = { defineMutationMethods: Meteor.isClient };                                                    // 38
// Set to `true` on the client so that method simulation works. Set to `false` on the server                           //
// so that we can be extra certain that all mutations must go through methods.                                         //
                                                                                                                       //
// Users = new Mongo.Collection("users");                                                                              //
// The users collection is special and can be accessed through `Meteor.users`.                                         //
// See https://docs.meteor.com/#/full/meteor_users.                                                                    //
//                                                                                                                     //
// There are two distinct types of entries in the users collection: identities and accounts. An                        //
// identity contains personal profile information and typically includes some intrinsic method for                     //
// authenticating as the owner of that information.                                                                    //
//                                                                                                                     //
// An account is an owner of app actions, grains, contacts, notifications, and payment info.                           //
// Each account can have multiple identities linked to it. To log in as an account you must first                      //
// authenticate as one of its linked identities.                                                                       //
//                                                                                                                     //
// Every user contains the following fields:                                                                           //
//   _id: Unique string ID. For accounts, this is random. For identities, this is the globally                         //
//        stable SHA-256 ID of this identity, hex-encoded.                                                             //
//   createdAt: Date when this entry was added to the collection.                                                      //
//   lastActive: Date of the user's most recent interaction with this Sandstorm server.                                //
//   services: Object containing login data used by Meteor authentication services.                                    //
//   expires: Date when this user should be deleted. Only present for demo users.                                      //
//   upgradedFromDemo: If present, the date when this user was upgraded from being a demo user.                        //
//                     TODO(cleanup): Unlike other dates in our database, this is stored as a number                   //
//                     rather than as a Date object. We should fix that.                                               //
//   appDemoId: If present and non-null, then the user is a demo user who arrived via an /appdemo/                     //
//              link. This field contains the app ID of the app that the user started out demoing.                     //
//              Unlike the `expires` field, this field is not cleared when the user upgrades from                      //
//              being a demo user.                                                                                     //
//   suspended: If this exists, this account/identity is supsended. Both accounts and identities                       //
//              can be suspended. After some amount of time, the user will be completely deleted                       //
//              and removed from the DB.                                                                               //
//              It is an object with fields:                                                                           //
//                voluntary: Boolean. This is true if the user initiated it. They will have the                        //
//                  chance to still login and reverse the suspension/deletion.                                         //
//                admin: The userId of the admin who suspended the account.                                            //
//                timestamp: Date object. When the suspension occurred.                                                //
//                willDelete: Boolean. If true, this account will be deleted after some time.                          //
//                                                                                                                     //
// Identity users additionally contain the following fields:                                                           //
//   profile: Object containing the data that will be shared with users and grains that come into                      //
//            contact with this identity. Includes the following fields:                                               //
//       service: String containing the name of this identity's authentication method.                                 //
//       name: String containing the chosen display name of the identity.                                              //
//       handle: String containing the identity's preferred handle.                                                    //
//       picture: _id into the StaticAssets table for the identity's picture. If not present,                          //
//                an identicon will be used.                                                                           //
//       pronoun: One of "male", "female", "neutral", or "robot".                                                      //
//   unverifiedEmail: If present, a string containing an email address specified by the user.                          //
//   referredBy: ID of the Account that referred this Identity.                                                        //
//                                                                                                                     //
// Account users additionally contain the following fields:                                                            //
//   loginIdentities: Array of identity objects, each of which may include the following fields.                       //
//       id: The globally-stable SHA-256 ID of this identity, hex-encoded.                                             //
//   nonloginIdentities: Array of identity objects, of the same form as `loginIdentities`. We use                      //
//                       a separate array here so that we can use a Mongo index to enforce the                         //
//                       invariant that an identity only be a login identity for a single account.                     //
//   primaryEmail: String containing this account's primary email address. Must be a verified adress                   //
//                 of one of this account's linked identities. Call SandstormDb.getUserEmails()                        //
//                 to do this checking automatically.                                                                  //
//   isAdmin: Boolean indicating whether this account is allowed to access the Sandstorm admin panel.                  //
//   signupKey: If this is an invited user, then this field contains their signup key.                                 //
//   signupNote: If the user was invited through a link, then this field contains the note that the                    //
//               inviter admin attached to the key.                                                                    //
//   signupEmail: If the user was invited by email, then this field contains the email address that                    //
//                the invite was sent to.                                                                              //
//   hasCompletedSignup: True if this account has confirmed its profile and agreed to this server's                    //
//                       terms of service.                                                                             //
//   plan: _id of an entry in the Plans table which determines the user's quota.                                       //
//   planBonus: {storage, compute, grains} bonus amounts to add to the user's plan. The payments                       //
//              module writes data here; we merely read it. Missing fields should be treated as                        //
//              zeroes. Does not yet include referral bonus, which is calculated separately.                           //
//              TODO(cleanup): Use for referral bonus too.                                                             //
//   storageUsage: Number of bytes this user is currently storing.                                                     //
//   payments: Object defined by payments module, if loaded.                                                           //
//   dailySentMailCount: Number of emails sent by this user today; used to limit spam.                                 //
//   accessRequests: Object containing the following fields; used to limit spam.                                       //
//       count: Number of "request access" emails during sent during the current interval.                             //
//       resetOn: Date when the count should be reset.                                                                 //
//   referredByComplete: ID of the Account that referred this Account. If this is set, we                              //
//                        stop writing new referredBy values onto Identities for this account.                         //
//   referredCompleteDate: The Date at which the completed referral occurred.                                          //
//   referredIdentityIds: List of Identity IDs that this Account has referred. This is used for                        //
//                        reliably determining which Identity's names are safe to display.                             //
//   experiments: Object where each field is an experiment that the user is in, and each value                         //
//           is the parameters for that experiment. Typically, the value simply names which                            //
//           experiment group which the user is in, where "control" is one group. If an experiment                     //
//           is not listed, then the user should not be considered at all for the purpose of that                      //
//           experiment. Each experiment may define a point in time where users not already in the                     //
//           experiment may be added to it and assigned to a group (for example, at user creation                      //
//           time). Current experiments:                                                                               //
//       firstTimeBillingPrompt: Value is "control" or "test". Users are assigned to groups at                         //
//               account creation on servers where billing is enabled (i.e. Oasis). Users in the                       //
//               test group will see a plan selection dialog and asked to make an explitic choice                      //
//               (possibly "free") before they can create grains (but not when opening someone                         //
//               else's shared grain). The goal of the experiment is to determine whether this                         //
//               prompt scares users away -- and also whether it increases paid signups.                               //
//       freeGrainLimit: Value is "control" or or a number indicating the grain limit that the                         //
//               user should receive when on the "free" plan, e.g. "Infinity".                                         //
//   stashedOldUser: A complete copy of this user from before the accounts/identities migration.                       //
//                   TODO(cleanup): Delete this field once we're sure it's safe to do so.                              //
                                                                                                                       //
Meteor.users.ensureIndexOnServer("services.google.email", { sparse: 1 });                                              // 141
Meteor.users.ensureIndexOnServer("services.github.emails.email", { sparse: 1 });                                       // 142
Meteor.users.ensureIndexOnServer("services.email.email", { unique: 1, sparse: 1 });                                    // 143
Meteor.users.ensureIndexOnServer("loginIdentities.id", { unique: 1, sparse: 1 });                                      // 144
Meteor.users.ensureIndexOnServer("nonloginIdentities.id", { sparse: 1 });                                              // 145
Meteor.users.ensureIndexOnServer("services.google.id", { unique: 1, sparse: 1 });                                      // 146
Meteor.users.ensureIndexOnServer("services.github.id", { unique: 1, sparse: 1 });                                      // 147
Meteor.users.ensureIndexOnServer("suspended.willDelete", { sparse: 1 });                                               // 148
                                                                                                                       //
// TODO(cleanup): This index is obsolete; delete it.                                                                   //
Meteor.users.ensureIndexOnServer("identities.id", { unique: 1, sparse: 1 });                                           // 151
                                                                                                                       //
Packages = new Mongo.Collection("packages", collectionOptions);                                                        // 153
// Packages which are installed or downloading.                                                                        //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:  128-bit prefix of SHA-256 hash of spk file, hex-encoded.                                                    //
//   status:  String.  One of "download", "verify", "unpack", "analyze", "ready", "failed", "delete"                   //
//   progress:  Float.  -1 = N/A, 0-1 = fractional progress (e.g. download percentage),                                //
//       >1 = download byte count.                                                                                     //
//   error:  If status is "failed", error message string.                                                              //
//   manifest:  If status is "ready", the package manifest.  See "Manifest" in package.capnp.                          //
//   appId:  If status is "ready", the application ID string.  Packages representing different                         //
//       versions of the same app have the same appId.  The spk tool defines the app ID format                         //
//       and can cryptographically verify that a package belongs to a particular app ID.                               //
//   shouldCleanup:  If true, a reference to this package was recently dropped, and the package                        //
//       collector should at some point check whether there are any other references and, if not,                      //
//       delete the package.                                                                                           //
//   url:  When status is "download", the URL from which the SPK can be obtained, if provided.                         //
//   isAutoUpdated: This package was downloaded as part of an auto-update. We shouldn't clean it up                    //
//     even if it has no users.                                                                                        //
//   authorPgpKeyFingerprint: Verified PGP key fingerprint (SHA-1, hex, all-caps) of the app                           //
//     packager.                                                                                                       //
                                                                                                                       //
DevPackages = new Mongo.Collection("devpackages", collectionOptions);                                                  // 175
// List of packages currently made available via the dev tools running on the local machine.                           //
// This is normally empty; the only time it is non-empty is when a developer is using the spk tool                     //
// on the local machine to publish an under-development app to this server. That should only ever                      //
// happen on developers' desktop machines.                                                                             //
//                                                                                                                     //
// While a dev package is published, it automatically appears as installed by every user of the                        //
// server, and it overrides all packages with the same application ID. If any instances of those                       //
// packages are currently open, they are killed and reset on publish.                                                  //
//                                                                                                                     //
// When the dev tool disconnects, the package is automatically unpublished, and any open instances                     //
// are again killed and refreshed.                                                                                     //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:  The package ID string (as with Packages._id).                                                               //
//   appId: The app ID this package is intended to override (as with Packages.appId).                                  //
//   timestamp:  Time when the package was last updated. If this changes while the package is                          //
//     published, all running instances are reset. This is used e.g. to reset the app each time                        //
//     changes are made to the source code.                                                                            //
//   manifest:  The app's manifest, as with Packages.manifest.                                                         //
//   mountProc: True if the supervisor should mount /proc.                                                             //
                                                                                                                       //
UserActions = new Mongo.Collection("userActions", collectionOptions);                                                  // 197
// List of actions that each user has installed which create new grains.  Each app may install                         //
// some number of actions (usually, one).                                                                              //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:  random                                                                                                      //
//   userId:  Account ID of the user who has installed this action.                                                    //
//   packageId:  Package used to run this action.                                                                      //
//   appId:  Same as Packages.findOne(packageId).appId; denormalized for searchability.                                //
//   appTitle:  Same as Packages.findOne(packageId).manifest.appTitle; denormalized so                                 //
//       that clients can access it without subscribing to the Packages collection.                                    //
//   appVersion:  Same as Packages.findOne(packageId).manifest.appVersion; denormalized for                            //
//       searchability.                                                                                                //
//   appMarketingVersion:  Human-readable presentation of the app version, e.g. "2.9.17"                               //
//   title: JSON-encoded LocalizedText title for this action, e.g.                                                     //
//       `{defaultText: "New Spreadsheet"}`.                                                                           //
//   nounPhrase: JSON-encoded LocalizedText describing what is created when this action is run.                        //
//   command:  Manifest.Command to run this action (see package.capnp).                                                //
                                                                                                                       //
Grains = new Mongo.Collection("grains", collectionOptions);                                                            // 216
// Grains belonging to users.                                                                                          //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:  random                                                                                                      //
//   packageId:  _id of the package of which this grain is an instance.                                                //
//   packageSalt: If present, a random string that will used in session ID generation. This field                      //
//       is usually updated when `packageId` is updated, triggering automatic refreshes for                            //
//       clients with active sessions.                                                                                 //
//   appId:  Same as Packages.findOne(packageId).appId; denormalized for searchability.                                //
//   appVersion:  Same as Packages.findOne(packageId).manifest.appVersion; denormalized for                            //
//       searchability.                                                                                                //
//   userId: The _id of the account that owns this grain.                                                              //
//   identityId: The identity with which the owning account prefers to open this grain.                                //
//   title:  Human-readable string title, as chosen by the user.                                                       //
//   lastUsed:  Date when the grain was last used by a user.                                                           //
//   private: If true, then knowledge of `_id` does not suffice to open this grain.                                    //
//   cachedViewInfo: The JSON-encoded result of `UiView.getViewInfo()`, cached from the most recent                    //
//                   time a session to this grain was opened.                                                          //
//   trashed: If present, the Date when this grain was moved to the trash bin. Thirty days after                       //
//            this date, the grain will be automatically deleted.                                                      //
//   suspended: If true, the owner of this grain has been suspended. They will soon be deleted,                        //
//              so treat this grain the same as "trashed". It is denormalized out of Users for ease                    //
//              of querying.                                                                                           //
//   ownerSeenAllActivity: True if the owner has viewed the grain since the last activity event                        //
//       occurred. See also ApiTokenOwner.user.seenAllActivity.                                                        //
//   size: On-disk size of the grain in bytes.                                                                         //
//                                                                                                                     //
// The following fields *might* also exist. These are temporary hacks used to implement e-mail and                     //
// web publishing functionality without powerbox support; they will be replaced once the powerbox                      //
// is implemented.                                                                                                     //
//   publicId:  An id used to publicly identify this grain. Used e.g. to route incoming e-mail and                     //
//       web publishing. This field is initialized when first requested by the app.                                    //
                                                                                                                       //
RoleAssignments = new Mongo.Collection("roleAssignments", collectionOptions);                                          // 250
// *OBSOLETE* Before `user` was a variant of ApiTokenOwner, this collection was used to store edges                    //
// in the permissions sharing graph. This functionality has been subsumed by the ApiTokens                             //
// collection.                                                                                                         //
                                                                                                                       //
Contacts = new Mongo.Collection("contacts", collectionOptions);                                                        // 255
// Edges in the social graph.                                                                                          //
//                                                                                                                     //
// If Alice has Bob as a contact, then she is allowed to see Bob's profile information and Bob                         //
// will show up in her user-picker UI for actions like share-by-identity.                                              //
//                                                                                                                     //
// Contacts are not symmetric. Bob might be one of Alice's contacts even if Alice is not one of                        //
// Bob's.                                                                                                              //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id: random                                                                                                       //
//   ownerId: The accountId of the user account who owns this contact.                                                 //
//   petname: Human-readable label chosen by and only visible to the owner. Uniquely identifies                        //
//            the contact to the owner.                                                                                //
//   created: Date when this contact was created.                                                                      //
//   identityId: The `_id` of the user whose contact info this contains.                                               //
                                                                                                                       //
Sessions = new Mongo.Collection("sessions", collectionOptions);                                                        // 272
// UI sessions open to particular grains.  A new session is created each time a user opens a grain.                    //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:  String generated as a SHA256 hash of the grain ID, the user ID, a salt generated by the                     //
//       client, and the grain's `packageSalt`.                                                                        //
//   grainId:  _id of the grain to which this session is connected.                                                    //
//   hostId: ID part of the hostname from which this grain is being served. I.e. this replaces the                     //
//       '*' in WILDCARD_HOST.                                                                                         //
//   tabId: Random value unique to the grain tab in which this session is displayed. Typically                         //
//       every session has a different `tabId`, but embedded sessions (including in the powerbox)                      //
//       have the same `tabId` as the outer session.                                                                   //
//   timestamp:  Time of last keep-alive message to this session.  Sessions time out after some                        //
//       period.                                                                                                       //
//   userId:  Account ID of the user who owns this session.                                                            //
//   identityId:  Identity ID of the user who owns this session.                                                       //
//   hashedToken: If the session is owned by an anonymous user, the _id of the entry in ApiTokens                      //
//       that was used to open it. Note that for old-style sharing (i.e. when !grain.private),                         //
//       anonymous users can get access without an API token and so neither userId nor hashedToken                     //
//       are present.                                                                                                  //
//   powerboxView: If present, this is a view that should be presented as part of a powerbox                           //
//       interaction.                                                                                                  //
//     offer: The webkey that corresponds to cap that was passed to the `offer` RPC.                                   //
//   viewInfo: The UiView.ViewInfo corresponding to the underlying UiSession. This isn't populated                     //
//       until newSession is called on the UiView.                                                                     //
//   permissions: The permissions for the current identity on this UiView. This isn't populated                        //
//       until newSession is called on the UiView.                                                                     //
//   hasLoaded: Marked as true by the proxy when the underlying UiSession has responded to its first                   //
//       request                                                                                                       //
                                                                                                                       //
SignupKeys = new Mongo.Collection("signupKeys", collectionOptions);                                                    // 302
// Invite keys which may be used by users to get access to Sandstorm.                                                  //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:  random                                                                                                      //
//   used:  Boolean indicating whether this key has already been consumed.                                             //
//   note:  Text note assigned when creating key, to keep track of e.g. whom the key was for.                          //
//   email: If this key was sent as an email invite, the email address to which it was sent.                           //
                                                                                                                       //
ActivityStats = new Mongo.Collection("activityStats", collectionOptions);                                              // 311
// Contains usage statistics taken on a regular interval. Each entry is a data point.                                  //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   timestamp: Date when measurements were taken.                                                                     //
//   daily: Contains stats counts pertaining to the last day before the sample time.                                   //
//   weekly: Contains stats counts pertaining to the last seven days before the sample time.                           //
//   monthly: Contains stats counts pertaining to the last thirty days before the timestamp.                           //
//                                                                                                                     //
// Each of daily, weekly, and monthly contains:                                                                        //
//   activeUsers: The number of unique users who have used a grain on the server in the time                           //
//       interval. Only counts logged-in users.                                                                        //
//   demoUsers: Demo users.                                                                                            //
//   appDemoUsers: Users that came in through "app demo".                                                              //
//   activeGrains: The number of unique grains that have been used in the time interval.                               //
//   apps: An object indexed by app ID recording, for each app:                                                        //
//       owners: Number of unique owners of this app (counting only grains that still exist).                          //
//       sharedUsers: Number of users who have accessed other people's grains of this app (counting                    //
//         only grains that still exist).                                                                              //
//       grains: Number of active grains of this app (that still exist).                                               //
//       deleted: Number of non-demo grains of this app that were deleted.                                             //
//       demoed: Number of demo grains created and expired.                                                            //
//       appDemoUsers: Number of app demos initiated with this app.                                                    //
                                                                                                                       //
DeleteStats = new Mongo.Collection("deleteStats", collectionOptions);                                                  // 335
// Contains records of objects that were deleted, for stat-keeping purposes.                                           //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   type: "grain" or "user" or "demoGrain" or "demoUser" or "appDemoUser"                                             //
//   lastActive: Date of the user's or grain's last activity.                                                          //
//   appId: For type = "grain", the app ID of the grain. For type = "appDemoUser", the app ID they                     //
//     arrived to demo. For others, undefined.                                                                         //
//   experiments: The experiments the user (or owner of the grain) was in. See user.experiments.                       //
                                                                                                                       //
FileTokens = new Mongo.Collection("fileTokens", collectionOptions);                                                    // 345
// Tokens corresponding to backup files that are currently stored on the server. A user receives                       //
// a token when they create a backup file (either by uploading it, or by backing up one of their                       //
// grains) and may use the token to read the file (either to download it, or to restore a new                          //
// grain from it).                                                                                                     //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:       The unguessable token string.                                                                          //
//   name:      Suggested filename.                                                                                    //
//   timestamp: File creation time. Used to figure out when the token and file should be wiped.                        //
                                                                                                                       //
ApiTokens = new Mongo.Collection("apiTokens", collectionOptions);                                                      // 356
// Access tokens for APIs exported by apps.                                                                            //
//                                                                                                                     //
// Originally API tokens were only used by external users through the HTTP API endpoint. However,                      //
// now they are also used to implement SturdyRefs, not just held by external users, but also when                      //
// an app holds a SturdyRef to another app within the same server. See the various `save()`,                           //
// `restore()`, and `drop()` methods in `grain.capnp` (on `SandstormApi`, `AppPersistent`, and                         //
// `MainView`) -- the fields of type `Data` are API tokens.                                                            //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:       A SHA-256 hash of the token, base64-encoded.                                                           //
//   grainId:   The grain servicing this API. (Not present if the API isn't serviced by a grain.)                      //
//   identityId: For UiView capabilities, this is the identity for which the view is attenuated.                       //
//              That is, the UiView's newSession() method will intersect the requested permissions                     //
//              with this identity's permissions before forwarding on to the underlying app. If                        //
//              `identityId` is not present, then no identity attenuation is applied, i.e. this is                     //
//              a raw UiView as implemented by the app. (The `roleAssignment` field, below, may                        //
//              still apply. For non-UiView capabilities, `identityId` is never present. Note that                     //
//              this is NOT the identity against which the `requiredPermissions` parameter of                          //
//              `SandstormApi.restore()` is checked; that would be `owner.grain.introducerIdentity`.                   //
//   accountId: For tokens where `identityId` is set, the `_id` (in the Users table) of the account                    //
//              that created the token.                                                                                //
//   roleAssignment: If this API token represents a UiView, this field contains a JSON-encoded                         //
//              Grain.ViewSharingLink.RoleAssignment representing the permissions it carries. These                    //
//              permissions will be intersected with those held by `identityId` when the view is                       //
//              opened.                                                                                                //
//   forSharing: If true, requests sent to the HTTP API endpoint with this token will be treated as                    //
//              anonymous rather than as directly associated with `identityId`. This has no effect                     //
//              on the permissions granted.                                                                            //
//   objectId:  If present, this token represents an arbitrary Cap'n Proto capability exported by                      //
//              the app or its supervisor (whereas without this it strictly represents UiView).                        //
//              sturdyRef is the JSON-encoded SupervisorObjectId (defined in `supervisor.capnp`).                      //
//              Note that if the SupervisorObjectId contains an AppObjectId, that field is                             //
//              treated as type AnyPointer, and so encoded as a raw Cap'n Proto message.                               //
//   frontendRef: If present, this token actually refers to an object implemented by the front-end,                    //
//              not a particular grain. (`grainId` and `identityId` are not set.) This is an object                    //
//              containing exactly one of the following fields:                                                        //
//       notificationHandle: A `Handle` for an ongoing notification, as returned by                                    //
//                           `NotificationTarget.addOngoing`. The value is an `_id` from the                           //
//                           `Notifications` collection.                                                               //
//       ipNetwork: An IpNetwork capability that is implemented by the frontend. Eventually, this                      //
//                  will be moved out of the frontend and into the backend, but we'll migrate the                      //
//                  database when that happens. This field contains the boolean true to signify that                   //
//                  it has been set.                                                                                   //
//       ipInterface: Ditto IpNetwork, except it's an IpInterface.                                                     //
//       emailVerifier: An EmailVerifier capability that is implemented by the frontend. The                           //
//                      value is an object containing the fields `id` and `services`. `id` is the                      //
//                      value returned by `EmailVerifier.getId()` and is used as part of a                             //
//                      powerbox query for matching verified emails. `services` is a                                   //
//                      list of names of identity providers that are trusted to verify addresses.                      //
//                      If `services` is omitted or falsy, all configured identity providers are                       //
//                      trusted. Note that a malicious user could specify invalid names in the                         //
//                      list; they should be ignored.                                                                  //
//       verifiedEmail: An VerifiedEmail capability that is implemented by the frontend.                               //
//                      An object containing `verifierId`, `tabId`, and `address`.                                     //
//       identity: An Identity capability. The field is the identity ID.                                               //
//   parentToken: If present, then this token represents exactly the capability represented by                         //
//              the ApiToken with _id = parentToken, except possibly (if it is a UiView) attenuated                    //
//              by `roleAssignment` (if present). To facilitate permissions computations, if the                       //
//              capability is a UiView, then `grainId` is set to the backing grain, `identityId`                       //
//              is set to the identity that shared the view, and `accountId` is set to the account                     //
//              that shared the view. Neither `objectId` nor `frontendRef` is present when                             //
//              `parentToken` is present.                                                                              //
//   petname:   Human-readable label for this access token, useful for identifying tokens for                          //
//              revocation. This should be displayed when visualizing incoming capabilities to                         //
//              the grain identified by `grainId`.                                                                     //
//   created:   Date when this token was created.                                                                      //
//   revoked:   If true, then this sturdyref has been revoked and can no longer be restored. It may                    //
//              become un-revoked in the future.                                                                       //
//   trashed:   If present, the Date when this token was moved to the trash bin. Thirty days after                     //
//              this date, the token will be automatically deleted.                                                    //
//   suspended: If true, the owner of this token has been suspended. They will soon be deleted,                        //
//              so treat this token the same as "trashed". It is denormalized out of Users for                         //
//              ease of querying.                                                                                      //
//   expires:   Optional expiration Date. If undefined, the token does not expire.                                     //
//   lastUsed:  Optional Date when this token was last used.                                                           //
//   owner:     A `ApiTokenOwner` (defined in `supervisor.capnp`, stored as a JSON object)                             //
//              as passed to the `save()` call that created this token. If not present, treat                          //
//              as `webkey` (the default for `ApiTokenOwner`).                                                         //
//   expiresIfUnused:                                                                                                  //
//              Optional Date after which the token, if it has not been used yet, expires.                             //
//              This field should be cleared on a token's first use.                                                   //
//   requirements: List of conditions which must hold for this token to be considered valid.                           //
//              Semantically, this list specifies the powers which were *used* to originally                           //
//              create the token. If any condition in the list becomes untrue, then the token must                     //
//              be considered revoked, and all live refs and sturdy refs obtained transitively                         //
//              through it must also become revoked. Each item is the JSON serialization of the                        //
//              `MembraneRequirement` structure defined in `supervisor.capnp`.                                         //
//   hasApiHost: If true, there is an entry in ApiHosts for this token, which will need to be                          //
//              cleaned up when the token is.                                                                          //
//                                                                                                                     //
// It is important to note that a token's owner and provider are independent from each other. To                       //
// illustrate, here is an approximate definition of ApiToken in pseudo Cap'n Proto schema language:                    //
//                                                                                                                     //
// struct ApiToken {                                                                                                   //
//   owner :ApiTokenOwner;                                                                                             //
//   provider :union {                                                                                                 //
//     grain :group {                                                                                                  //
//       grainId :Text;                                                                                                //
//       union {                                                                                                       //
//         uiView :group {                                                                                             //
//           identityId :Text;                                                                                         //
//           roleAssignment :RoleAssignment;                                                                           //
//           forSharing :Bool;                                                                                         //
//         }                                                                                                           //
//         objectId :SupervisorObjectId;                                                                               //
//       }                                                                                                             //
//     }                                                                                                               //
//     frontendRef :union {                                                                                            //
//       notificationHandle :Text;                                                                                     //
//       ipNetwork :Bool;                                                                                              //
//       ipInterface :Bool;                                                                                            //
//       emailVerifier :group {                                                                                        //
//         id :Text;                                                                                                   //
//         services :List(String);                                                                                     //
//       }                                                                                                             //
//       verifiedEmail :group {                                                                                        //
//         verifierId :Text;                                                                                           //
//         tabId :Text;                                                                                                //
//         address :Text;                                                                                              //
//       }                                                                                                             //
//       identity :Text;                                                                                               //
//     }                                                                                                               //
//     child :group {                                                                                                  //
//       parentToken :Text;                                                                                            //
//       union {                                                                                                       //
//         uiView :group {                                                                                             //
//           grainId :Text;                                                                                            //
//           identityId :Text;                                                                                         //
//           roleAssignment :RoleAssignment = (allAccess = ());                                                        //
//         }                                                                                                           //
//         other :Void;                                                                                                //
//       }                                                                                                             //
//     }                                                                                                               //
//   }                                                                                                                 //
//   requirements: List(Supervisor.MembraneRequirement);                                                               //
//   ...                                                                                                               //
// }                                                                                                                   //
                                                                                                                       //
ApiTokens.ensureIndexOnServer("grainId", { sparse: 1 });                                                               // 495
ApiTokens.ensureIndexOnServer("owner.user.identityId", { sparse: 1 });                                                 // 496
ApiTokens.ensureIndexOnServer("frontendRef.emailVerifier.id", { sparse: 1 });                                          // 497
                                                                                                                       //
ApiHosts = new Mongo.Collection("apiHosts", collectionOptions);                                                        // 499
// Allows defining some limited static behavior for an API host when accessed unauthenticated. This                    //
// mainly exists to allow backwards-compatibility with client applications that expect to be able                      //
// to probe an API host without authentication to determine capabilities such as DAV protocols                         //
// supported, before authenticating to perform real requests. An app can specify these properties                      //
// when creating an offerTemplate.                                                                                     //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:          apiHostIdHashForToken() of the corresponding API token.                                             //
//   hash2:        hash(hash(token)), aka hash(ApiToken._id). Used to allow ApiHosts to be cleaned                     //
//                 up when ApiTokens are deleted.                                                                      //
//   options:      Specifies how to respond to unauthenticated OPTIONS requests on this host.                          //
//                 This is an object containing fields:                                                                //
//     dav:        List of strings specifying DAV header `compliance-class`es, e.g. "1" or                             //
//                 "calendar-access". https://tools.ietf.org/html/rfc4918#section-10.1                                 //
//   resources:    Object mapping URL paths (including initial '/') to static HTTP responses to                        //
//                 give when those paths are accessed unauthenticated. Due to Mongo disliking '.'                      //
//                 and '$' in keys, these characters must be escaped as '\uFF0E' and '\uFF04'                          //
//                 (see SandstormDb.escapeMongoKey). Each value in this map is an object with                          //
//                 fields:                                                                                             //
//     type:       Content-Type.                                                                                       //
//     language:   Content-Language.                                                                                   //
//     encoding:   Content-Encoding.                                                                                   //
//     body:       Entity-body as a string or buffer.                                                                  //
                                                                                                                       //
Notifications = new Mongo.Collection("notifications", collectionOptions);                                              // 524
// Notifications for a user.                                                                                           //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:          random                                                                                              //
//   grainId:      The grain originating this notification, if any.                                                    //
//   userId:       Account ID of the user receiving the notification.                                                  //
//   text:         The JSON-ified LocalizedText to display in the notification.                                        //
//   isUnread:     Boolean indicating if this notification is unread.                                                  //
//   timestamp:    Date when this notification was last updated                                                        //
//   eventType:    If this notification is due to an activity event, this is the numeric index                         //
//                 of the event type on the grain's ViewInfo.                                                          //
//   count:        The number of times this exact event has repeated. Identical events are                             //
//                 aggregated by incrementing the count.                                                               //
//   initiatingIdentity: Identity ID of the user who initiated this notification.                                      //
//   initiatorAnonymous: True if the initiator is an anonymous user. If neither this nor                               //
//                 initiatingIdentity is present, the notification is not from a user.                                 //
//   path:         Path inside the grain to which the user should be directed if they click on                         //
//                 the notification.                                                                                   //
//   ongoing:      If present, this is an ongoing notification, and this field contains an                             //
//                 ApiToken referencing the `OngoingNotification` capability.                                          //
//   admin:        If present, this is a notification intended for an admin.                                           //
//     action:     If present, this is a (string) link that the notification should direct the                         //
//                 admin to.                                                                                           //
//     type:       The type of notification -- can be "reportStats", "cantRenewFeatureKey", or                         //
//                 "trialFeatureKeyExpired".                                                                           //
//   appUpdates:   If present, this is an app update notification. It is an object with the appIds                     //
//                 as keys.                                                                                            //
//     $appId:     The appId that has an outstanding update.                                                           //
//       packageId: The packageId that it will update to.                                                              //
//       name: The name of the app. (appTitle from package.manifest)                                                   //
//       version: The app's version number. (appVersion from package.manifest)                                         //
//       marketingVersion: String marketing version of this app. (appMarketingVersion from package.manifest)           //
//   referral:     If this boolean field is true, then treat this notification as a referral                           //
//                 notification. This causes text to be ignored, since we need custom logic.                           //
//   mailingListBonus: Like `referral`, but notify the user about the mailing list bonus. This is                      //
//                 a one-time notification only to Oasis users who existed when the bonus program                      //
//                 was implemented.                                                                                    //
                                                                                                                       //
ActivitySubscriptions = new Mongo.Collection("activitySubscriptions", collectionOptions);                              // 563
// Activity events to which a user is subscribed.                                                                      //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:          random                                                                                              //
//   identityId:   Who is subscribed.                                                                                  //
//   grainId:      Grain to which subscription applies.                                                                //
//   threadPath:   If present, the subscription is on a specific thread. Otherwise, it is on the                       //
//                 whole grain.                                                                                        //
//   mute:         If true, this is an anti-subscription -- matching events should NOT notify.                         //
//                 This allows is useful to express:                                                                   //
//                 - A user wants to subscribe to a grain but mute a specific thread.                                  //
//                 - The owner of a grain does not want notifications (normally, they are                              //
//                   implicitly subscribed).                                                                           //
//                 - A user no longer wishes to be implicitly subscribed to threads in a grain on                      //
//                   which they comment, so they mute the grain.                                                       //
                                                                                                                       //
ActivitySubscriptions.ensureIndexOnServer("identityId");                                                               // 580
ActivitySubscriptions.ensureIndexOnServer({ "grainId": 1, "threadPath": 1 });                                          // 581
                                                                                                                       //
StatsTokens = new Mongo.Collection("statsTokens", collectionOptions);                                                  // 583
// Access tokens for the Stats collection                                                                              //
//                                                                                                                     //
// These tokens are used for accessing the ActivityStats collection remotely                                           //
// (ie. from a dashboard webapp)                                                                                       //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:       The token. At least 128 bits entropy (Random.id(22)).                                                  //
                                                                                                                       //
Misc = new Mongo.Collection("misc", collectionOptions);                                                                // 592
// Miscellaneous configuration and other settings                                                                      //
//                                                                                                                     //
// This table is currently only used for persisting BASE_URL from one session to the next,                             //
// but in general any miscellaneous settings should go in here                                                         //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:       The name of the setting. eg. "BASE_URL"                                                                //
//   value:     The value of the setting.                                                                              //
                                                                                                                       //
Settings = new Mongo.Collection("settings", collectionOptions);                                                        // 602
// Settings for this Sandstorm instance go here. They are configured through the adminSettings                         //
// route. This collection differs from misc in that any admin user can update it through the admin                     //
// interface.                                                                                                          //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:       The name of the setting. eg. "smtpConfig"                                                              //
//   value:     The value of the setting.                                                                              //
//   automaticallyReset: Sometimes the server needs to automatically reset a setting. When it does                     //
//                       so, it will also write an object to this field indicating why the reset was                   //
//                       needed. That object can have the following variants:                                          //
//       baseUrlChangedFrom: The reset was due to BASE_URL changing. This field contains a string                      //
//                           with the old BASE_URL.                                                                    //
//   preinstalledApps: A list of objects:                                                                              //
//     appId: The Packages.appId of the app to install                                                                 //
//     status: packageId                                                                                               //
//     packageId: The Packages._id of the app to install                                                               //
//                                                                                                                     //
//   potentially other fields that are unique to the setting                                                           //
                                                                                                                       //
Migrations = new Mongo.Collection("migrations", collectionOptions);                                                    // 622
// This table tracks which migrations we have applied to this instance.                                                //
// It contains a single entry:                                                                                         //
//   _id:       "migrations_applied"                                                                                   //
//   value:     The number of migrations this instance has successfully completed.                                     //
                                                                                                                       //
StaticAssets = new Mongo.Collection("staticAssets", collectionOptions);                                                // 628
// Collection of static assets served up from the Sandstorm server's "static" host. We only                            //
// support relatively small assets: under 1MB each.                                                                    //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:       Random ID; will be used in the URL.                                                                    //
//   hash:      A base64-encoded SHA-256 hash of the data, used to de-dupe.                                            //
//   mimeType:  MIME type of the asset, suitable for Content-Type header.                                              //
//   encoding:  Either "gzip" or not present, suitable for Content-Encoding header.                                    //
//   content:   The asset content (byte buffer).                                                                       //
//   refcount:  Number of places where this asset's ID appears in the database. Since Mongo doesn't                    //
//       have transactions, this needs to bias towards over-counting; a backup GC could be used                        //
//       to catch leaked assets, although it's probably not a big deal in practice.                                    //
                                                                                                                       //
AssetUploadTokens = new Mongo.Collection("assetUploadTokens", collectionOptions);                                      // 642
// Collection of tokens representing a single-use permission to upload an asset, such as a new                         //
// profile picture.                                                                                                    //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:       Random ID.                                                                                             //
//   purpose:   Contains one of the following, indicating how the asset is to be used:                                 //
//       profilePicture: Indicates that the upload is a new profile picture. Contains fields:                          //
//           userId: Account ID of user whose picture shall be replaced.                                               //
//           identityId: Which of the user's identities shall be updated.                                              //
//   expires:   Time when this token will go away if unused.                                                           //
                                                                                                                       //
Plans = new Mongo.Collection("plans", collectionOptions);                                                              // 654
// Subscription plans, which determine quota.                                                                          //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id: Plan ID, usually a short string like "free", "standard", "large", "mega", ...                                //
//   storage: Number of bytes this user is allowed to store.                                                           //
//   compute: Number of kilobyte-RAM-seconds this user is allowed to consume.                                          //
//   computeLabel: Label to display to the user describing this plan's compute units.                                  //
//   grains: Total number of grains this user can create (often `Infinity`).                                           //
//   price: Price per month in US cents.                                                                               //
//   hidden: If true, a user cannot switch to this plan, but some users may be on it and are                           //
//       allowed to switch away.                                                                                       //
//   title: Title from display purposes. If missing, default to capitalizing _id.                                      //
                                                                                                                       //
AppIndex = new Mongo.Collection("appIndex", collectionOptions);                                                        // 668
// A mirror of the data from the App Market index                                                                      //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id: the appId of the app                                                                                         //
//  The rest of the fields are defined in src/sandstorm/app-index/app-index.capnp:AppIndexForMarket                    //
                                                                                                                       //
KeybaseProfiles = new Mongo.Collection("keybaseProfiles", collectionOptions);                                          // 675
// Cache of Keybase profile information. The profile for a user is re-fetched every time a package                     //
// by that user is installed, as well as if the keybase profile is requested and not already                           //
// present for some reason.                                                                                            //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id: PGP key fingerprint (SHA-1, hex, all-caps)                                                                   //
//   displayName: Display name from Keybase. (NOT VERIFIED AT ALL.)                                                    //
//   handle: Keybase handle.                                                                                           //
//   proofs: The "proofs_summary.all" array from the Keybase lookup. See the non-existent Keybase                      //
//     docs for details. We also add a boolean "status" field to each proof indicating whether                         //
//     we have directly verified the proof ourselves. Its values may be "unverified" (Keybase                          //
//     returned this but we haven't checked it directly), "verified" (we verified the proof and it                     //
//     is valid), "invalid" (we checked the proof and it was definitely bogus), or "checking" (the                     //
//     server is currently actively checking this proof). Note that if a check fails due to network                    //
//     errors, the status goes back to "unverified".                                                                   //
//                                                                                                                     //
//     WARNING: Currently verification is NOT IMPLEMENTED, so all proofs will be "unverified"                          //
//       for now and we just trust Keybase.                                                                            //
                                                                                                                       //
FeatureKey = new Mongo.Collection("featureKey", collectionOptions);                                                    // 695
// Responsible for storing the current feature key that is active on the server.  Contains a single                    //
// document with two keys:                                                                                             //
//                                                                                                                     //
//   _id: "currentFeatureKey"                                                                                          //
//   value: the still-signed, binary-encoded feature key                                                               //
//          (a feature key with comments removed and base64 decoded)                                                   //
//   renewalProblem: If we tried to renew this feature key and failed, an object describing that                       //
//       failure. Includes exactly one of the following fields:                                                        //
//     noPaymentSource: True, indicating that the key could not be renewed because there was no                        //
//         payment source set for this key.                                                                            //
//     paymentFailed: String error message returned by our payment processor describing why they                       //
//         declined the charge.                                                                                        //
//     noSuchKey: True, indicating the key doesn't exist.                                                              //
//     revoked: True, indicating the key has been revoked.                                                             //
//     unknownResponse: String response text from the renewal API which wasn't recognized. Should                      //
//         be reported to Sandstorm.                                                                                   //
//     exception: String error message from an exception thrown by the renewal code. This usually                      //
//         indicates some sort of connectivity problem, so could be reported to the user as:                           //
//         "There was a problem reaching the feature key renewal server."                                              //
//                                                                                                                     //
// This is only intended to be visible on the server.                                                                  //
                                                                                                                       //
SetupSession = new Mongo.Collection("setupSession", collectionOptions);                                                // 718
// Responsible for storing information about setup sessions.  Contains a single document with three                    //
// keys:                                                                                                               //
//                                                                                                                     //
//   _id: "current-session"                                                                                            //
//   creationDate: Date object indicating when this session was created.                                               //
//   hashedSessionId: the sha256 of the secret session id that was returned to the client                              //
                                                                                                                       //
var DesktopNotifications = new Mongo.Collection("desktopNotifications", collectionOptions);                            // 726
// Responsible for very short-lived queueing of desktop notification information.                                      //
// Entries are removed when they are ~30 seconds old.  This collection is a bit                                        //
// odd in that it is intended primarily for edge-triggered communications, but                                         //
// Meteor's collections aren't really designed to support that organization.                                           //
// Fields for each :                                                                                                   //
//                                                                                                                     //
//   _id: String.  Used as the tag to coordinate notification merging between browser tabs.                            //
//   creationDate: Date object. indicating when this notification was posted.                                          //
//   userId: String. Account id to which this notification was published.                                              //
//   notificationId: String.  ID of the matching event in the Notifications table to dismiss if this                   //
//                            notification is activated.                                                               //
//   appActivity: Object with fields:                                                                                  //
//     user: Optional Object. Not present if this notification wasn't generated by a user. If                          //
//           present, it will have one of the following shapes:                                                        //
//       { anonymous: true } if this notification was generated by an anonymous user.  Otherwise:                      //
//       {                                                                                                             //
//         identityId: String  The user's identity ID.                                                                 //
//         name: String        The user's display name.                                                                //
//         avatarUrl: String   The URL for the user's profile picture.                                                 //
//       },                                                                                                            //
//     grainId: String,      Which grain this action took place on                                                     //
//     path: String,         The path of the notification.                                                             //
//     body: Util.LocalizedText,  The main body of the activity event.                                                 //
//     actionText: Util.LocalizedText, What action the user took, e.g.                                                 //
//                                     { defaultText: "added a comment" }                                              //
                                                                                                                       //
var StandaloneDomains = new Mongo.Collection("standaloneDomains", collectionOptions);                                  // 753
// A standalone domain that points to a single share link. These domains act a little different                        //
// than a normal shared Sandstorm grain. They completely drop any Sandstorm topbar/sidebar, and at                     //
// first glance look completely like a non-Sandstorm hosted webserver. The apps instead act in                         //
// concert with Sandstorm through the postMessage API, which allows it to do things like prompt for                    //
// login.                                                                                                              //
// Fields for each :                                                                                                   //
//                                                                                                                     //
//   _id: String. The domain name to use.                                                                              //
//   token: String. _id of a sharing token (it must be a webkey).                                                      //
                                                                                                                       //
if (Meteor.isServer) {                                                                                                 // 764
  Meteor.publish("credentials", function () {                                                                          // 765
    // Data needed for isSignedUp() and isAdmin() to work.                                                             //
                                                                                                                       //
    if (this.userId) {                                                                                                 // 768
      var db = this.connection.sandstormDb;                                                                            // 769
      return [Meteor.users.find({ _id: this.userId }, { fields: { signupKey: 1, isAdmin: 1, expires: 1, storageUsage: 1,
          plan: 1, planBonus: 1, hasCompletedSignup: 1, experiments: 1,                                                // 773
          referredIdentityIds: 1, cachedStorageQuota: 1, suspended: 1 } }), db.collections.plans.find()];              // 774
    } else {                                                                                                           // 777
      return [];                                                                                                       // 778
    }                                                                                                                  // 779
  });                                                                                                                  // 780
}                                                                                                                      // 781
                                                                                                                       //
var countReferrals = function countReferrals(user) {                                                                   // 783
  var referredIdentityIds = user.referredIdentityIds;                                                                  // 784
  return referredIdentityIds && referredIdentityIds.length || 0;                                                       // 785
};                                                                                                                     // 786
                                                                                                                       //
var calculateReferralBonus = function calculateReferralBonus(user) {                                                   // 788
  // This function returns an object of the form:                                                                      //
  //                                                                                                                   //
  // - {grains: 0, storage: 0}                                                                                         //
  //                                                                                                                   //
  // which are extra resources this account gets as part of participating in the referral                              //
  // program. (Storage is measured in bytes, as usual for plans.)                                                      //
                                                                                                                       //
  // TODO(cleanup): Consider moving referral bonus logic into Oasis payments module (since it's                        //
  //   payments-specific) and aggregating into `planBonus`.                                                            //
                                                                                                                       //
  // Authorization note: Only call this if accountId is the current user!                                              //
  var isPaid = user.plan && user.plan !== "free";                                                                      // 800
                                                                                                                       //
  successfulReferralsCount = countReferrals(user);                                                                     // 802
  if (isPaid) {                                                                                                        // 803
    var maxPaidStorageBonus = 30 * 1e9;                                                                                // 804
    return { grains: 0,                                                                                                // 805
      storage: Math.min(successfulReferralsCount * 2 * 1e9, maxPaidStorageBonus) };                                    // 806
  } else {                                                                                                             // 809
    var maxFreeStorageBonus = 2 * 1e9;                                                                                 // 810
    var bonus = {                                                                                                      // 811
      storage: Math.min(successfulReferralsCount * 50 * 1e6, maxFreeStorageBonus)                                      // 812
    };                                                                                                                 // 811
    if (successfulReferralsCount > 0) {                                                                                // 816
      bonus.grains = Infinity;                                                                                         // 817
    } else {                                                                                                           // 818
      bonus.grains = 0;                                                                                                // 819
    }                                                                                                                  // 820
                                                                                                                       //
    return bonus;                                                                                                      // 822
  }                                                                                                                    // 823
};                                                                                                                     // 824
                                                                                                                       //
isAdmin = function isAdmin() {                                                                                         // 826
  // Returns true if the user is the administrator.                                                                    //
                                                                                                                       //
  var user = Meteor.user();                                                                                            // 829
  if (user && user.isAdmin) {                                                                                          // 830
    return true;                                                                                                       // 831
  } else {                                                                                                             // 832
    return false;                                                                                                      // 833
  }                                                                                                                    // 834
};                                                                                                                     // 835
                                                                                                                       //
isAdminById = function isAdminById(id) {                                                                               // 837
  // Returns true if the user's id is the administrator.                                                               //
                                                                                                                       //
  var user = Meteor.users.findOne({ _id: id }, { fields: { isAdmin: 1 } });                                            // 840
  if (user && user.isAdmin) {                                                                                          // 841
    return true;                                                                                                       // 842
  } else {                                                                                                             // 843
    return false;                                                                                                      // 844
  }                                                                                                                    // 845
};                                                                                                                     // 846
                                                                                                                       //
findAdminUserForToken = function findAdminUserForToken(token) {                                                        // 848
  if (!token.requirements) {                                                                                           // 849
    return;                                                                                                            // 850
  }                                                                                                                    // 851
                                                                                                                       //
  var requirements = token.requirements.filter(function (requirement) {                                                // 853
    return "userIsAdmin" in requirement;                                                                               // 854
  });                                                                                                                  // 855
                                                                                                                       //
  if (requirements.length > 1) {                                                                                       // 857
    return;                                                                                                            // 858
  }                                                                                                                    // 859
                                                                                                                       //
  if (requirements.length === 0) {                                                                                     // 861
    return;                                                                                                            // 862
  }                                                                                                                    // 863
                                                                                                                       //
  return requirements[0].userIsAdmin;                                                                                  // 865
};                                                                                                                     // 866
                                                                                                                       //
var wildcardHost = Meteor.settings["public"].wildcardHost.toLowerCase().split("*");                                    // 868
                                                                                                                       //
if (wildcardHost.length != 2) {                                                                                        // 870
  throw new Error("Wildcard host must contain exactly one asterisk.");                                                 // 871
}                                                                                                                      // 872
                                                                                                                       //
matchWildcardHost = function matchWildcardHost(host) {                                                                 // 874
  // See if the hostname is a member of our wildcard. If so, extract the ID.                                           //
                                                                                                                       //
  // We remove everything after the first ":" character so that our                                                    //
  // comparison logic ignores port numbers.                                                                            //
  var prefix = wildcardHost[0];                                                                                        // 879
  var suffix = wildcardHost[1].split(":")[0];                                                                          // 880
  var hostSansPort = host.split(":")[0];                                                                               // 881
                                                                                                                       //
  if (hostSansPort.lastIndexOf(prefix, 0) >= 0 && hostSansPort.indexOf(suffix, -suffix.length) >= 0 && hostSansPort.length >= prefix.length + suffix.length) {
    var id = hostSansPort.slice(prefix.length, -suffix.length);                                                        // 886
    if (id.match(/^[-a-z0-9]*$/)) {                                                                                    // 887
      return id;                                                                                                       // 888
    }                                                                                                                  // 889
  }                                                                                                                    // 890
                                                                                                                       //
  return null;                                                                                                         // 892
};                                                                                                                     // 893
                                                                                                                       //
makeWildcardHost = function makeWildcardHost(id) {                                                                     // 895
  return wildcardHost[0] + id + wildcardHost[1];                                                                       // 896
};                                                                                                                     // 897
                                                                                                                       //
var isApiHostId = function isApiHostId(hostId) {                                                                       // 899
  if (hostId) {                                                                                                        // 900
    var split = hostId.split("-");                                                                                     // 901
    if (split[0] === "api") return split[1] || "*";                                                                    // 902
  }                                                                                                                    // 903
                                                                                                                       //
  return false;                                                                                                        // 905
};                                                                                                                     // 906
                                                                                                                       //
var isTokenSpecificHostId = function isTokenSpecificHostId(hostId) {                                                   // 908
  return hostId.lastIndexOf("api-", 0) === 0;                                                                          // 909
};                                                                                                                     // 910
                                                                                                                       //
var apiHostIdHashForToken = void 0;                                                                                    // 912
if (Meteor.isServer) {                                                                                                 // 913
  (function () {                                                                                                       // 913
    var Crypto = Npm.require("crypto");                                                                                // 914
    apiHostIdHashForToken = function apiHostIdHashForToken(token) {                                                    // 915
      // Given an API token, compute the host ID that must be used when requesting this token.                         //
                                                                                                                       //
      // We add a leading 'x' to the hash so that knowing the hostname alone is not sufficient to                      //
      // find the corresponding API token in the ApiTokens table (whose _id values are also hashes                     //
      // of tokens). This doesn't technically add any security, but helps prove that we don't have                     //
      // any bugs which would allow someone who knows only the hostname to access the app API.                         //
      return Crypto.createHash("sha256").update("x" + token).digest("hex").slice(0, 32);                               // 922
    };                                                                                                                 // 923
  })();                                                                                                                // 913
} else {                                                                                                               // 924
  apiHostIdHashForToken = function apiHostIdHashForToken(token) {                                                      // 925
    // Given an API token, compute the host ID that must be used when requesting this token.                           //
                                                                                                                       //
    // We add a leading 'x' to the hash so that knowing the hostname alone is not sufficient to                        //
    // find the corresponding API token in the ApiTokens table (whose _id values are also hashes                       //
    // of tokens). This doesn't technically add any security, but helps prove that we don't have                       //
    // any bugs which would allow someone who knows only the hostname to access the app API.                           //
    return SHA256("x" + token).slice(0, 32);                                                                           // 932
  };                                                                                                                   // 933
}                                                                                                                      // 934
                                                                                                                       //
var apiHostIdForToken = function apiHostIdForToken(token) {                                                            // 936
  return "api-" + apiHostIdHashForToken(token);                                                                        // 937
};                                                                                                                     // 938
                                                                                                                       //
var makeApiHost = function makeApiHost(token) {                                                                        // 940
  return makeWildcardHost(apiHostIdForToken(token));                                                                   // 941
};                                                                                                                     // 942
                                                                                                                       //
if (Meteor.isServer) {                                                                                                 // 944
  (function () {                                                                                                       // 944
    var Url = Npm.require("url");                                                                                      // 945
    getWildcardOrigin = function getWildcardOrigin() {                                                                 // 946
      // The wildcard URL can be something like "foo-*-bar.example.com", but sometimes when we're                      //
      // trying to specify a pattern matching hostnames (say, a Content-Security-Policy directive),                    //
      // an astrisk is only allowed as the first character and must be followed by a period. So we need                //
      // "*.example.com" instead -- which matches more than we actually want, but is the best we can                   //
      // really do. We also add the protocol to the front (again, that's what CSP wants).                              //
                                                                                                                       //
      // TODO(cleanup): `protocol` is computed in other files, like proxy.js. Put it somewhere common.                 //
      var protocol = Url.parse(process.env.ROOT_URL).protocol;                                                         // 954
                                                                                                                       //
      var dotPos = wildcardHost[1].indexOf(".");                                                                       // 956
      if (dotPos < 0) {                                                                                                // 957
        return protocol + "//*";                                                                                       // 958
      } else {                                                                                                         // 959
        return protocol + "//*" + wildcardHost[1].slice(dotPos);                                                       // 960
      }                                                                                                                // 961
    };                                                                                                                 // 962
  })();                                                                                                                // 944
}                                                                                                                      // 963
                                                                                                                       //
SandstormDb = function SandstormDb(quotaManager) {                                                                     // 965
  // quotaManager is an object with the following method:                                                              //
  //   updateUserQuota: It is provided two arguments                                                                   //
  //     db: This SandstormDb object                                                                                   //
  //     user: A collections.users account object                                                                      //
  //   and returns a quota object:                                                                                     //
  //     storage: A number (can be Infinity)                                                                           //
  //     compute: A number (can be Infinity)                                                                           //
  //     grains: A number (can be Infinity)                                                                            //
                                                                                                                       //
  this.quotaManager = quotaManager;                                                                                    // 975
  this.collections = {                                                                                                 // 976
    // Direct access to underlying collections. DEPRECATED, but better than accessing the top-level                    //
    // collection globals directly.                                                                                    //
    //                                                                                                                 //
    // TODO(cleanup): Over time, we will provide methods covering each supported query and remove                      //
    //   direct access to the collections.                                                                             //
    users: Meteor.users,                                                                                               // 982
                                                                                                                       //
    packages: Packages,                                                                                                // 984
    devPackages: DevPackages,                                                                                          // 985
    userActions: UserActions,                                                                                          // 986
    grains: Grains,                                                                                                    // 987
    roleAssignments: RoleAssignments, // Deprecated, only used by the migration that eliminated it.                    // 988
    contacts: Contacts,                                                                                                // 989
    sessions: Sessions,                                                                                                // 990
    signupKeys: SignupKeys,                                                                                            // 991
    activityStats: ActivityStats,                                                                                      // 992
    deleteStats: DeleteStats,                                                                                          // 993
    fileTokens: FileTokens,                                                                                            // 994
    apiTokens: ApiTokens,                                                                                              // 995
    apiHosts: ApiHosts,                                                                                                // 996
    notifications: Notifications,                                                                                      // 997
    activitySubscriptions: ActivitySubscriptions,                                                                      // 998
    statsTokens: StatsTokens,                                                                                          // 999
    misc: Misc,                                                                                                        // 1000
    settings: Settings,                                                                                                // 1001
    migrations: Migrations,                                                                                            // 1002
    staticAssets: StaticAssets,                                                                                        // 1003
    assetUploadTokens: AssetUploadTokens,                                                                              // 1004
    plans: Plans,                                                                                                      // 1005
    appIndex: AppIndex,                                                                                                // 1006
    keybaseProfiles: KeybaseProfiles,                                                                                  // 1007
    featureKey: FeatureKey,                                                                                            // 1008
    setupSession: SetupSession,                                                                                        // 1009
    desktopNotifications: DesktopNotifications,                                                                        // 1010
    standaloneDomains: StandaloneDomains                                                                               // 1011
  };                                                                                                                   // 976
};                                                                                                                     // 1013
                                                                                                                       //
// TODO(cleanup): These methods should not be defined freestanding and should use collection                           //
//   objects created in SandstormDb's constructor rather than globals.                                                 //
                                                                                                                       //
_.extend(SandstormDb.prototype, {                                                                                      // 1018
  isAdmin: isAdmin,                                                                                                    // 1019
  isAdminById: isAdminById,                                                                                            // 1020
  findAdminUserForToken: findAdminUserForToken,                                                                        // 1021
  matchWildcardHost: matchWildcardHost,                                                                                // 1022
  makeWildcardHost: makeWildcardHost,                                                                                  // 1023
  isApiHostId: isApiHostId,                                                                                            // 1024
  isTokenSpecificHostId: isTokenSpecificHostId,                                                                        // 1025
  apiHostIdHashForToken: apiHostIdHashForToken,                                                                        // 1026
  apiHostIdForToken: apiHostIdForToken,                                                                                // 1027
  makeApiHost: makeApiHost,                                                                                            // 1028
  allowDevAccounts: function allowDevAccounts() {                                                                      // 1029
    var setting = this.collections.settings.findOne({ _id: "devAccounts" });                                           // 1030
    if (setting) {                                                                                                     // 1031
      return setting.value;                                                                                            // 1032
    } else {                                                                                                           // 1033
      return Meteor.settings && Meteor.settings["public"] && Meteor.settings["public"].allowDevAccounts;               // 1034
    }                                                                                                                  // 1036
  },                                                                                                                   // 1037
                                                                                                                       //
                                                                                                                       //
  roleAssignmentPattern: {                                                                                             // 1039
    none: Match.Optional(null),                                                                                        // 1040
    allAccess: Match.Optional(null),                                                                                   // 1041
    roleId: Match.Optional(Match.Integer),                                                                             // 1042
    addPermissions: Match.Optional([Boolean]),                                                                         // 1043
    removePermissions: Match.Optional([Boolean])                                                                       // 1044
  },                                                                                                                   // 1039
                                                                                                                       //
  isDemoUser: function isDemoUser() {                                                                                  // 1047
    // Returns true if this is a demo user.                                                                            //
                                                                                                                       //
    var user = Meteor.user();                                                                                          // 1050
    if (user && user.expires) {                                                                                        // 1051
      return true;                                                                                                     // 1052
    } else {                                                                                                           // 1053
      return false;                                                                                                    // 1054
    }                                                                                                                  // 1055
  },                                                                                                                   // 1056
  isSignedUp: function isSignedUp() {                                                                                  // 1058
    var user = Meteor.user();                                                                                          // 1059
    return this.isAccountSignedUp(user);                                                                               // 1060
  },                                                                                                                   // 1061
  isAccountSignedUp: function isAccountSignedUp(user) {                                                                // 1063
    // Returns true if the user has presented an invite key.                                                           //
                                                                                                                       //
    if (!user) return false; // not signed in                                                                          // 1066
                                                                                                                       //
    if (!user.loginIdentities) return false; // not an account                                                         // 1068
                                                                                                                       //
    if (user.expires) return false; // demo user.                                                                      // 1070
                                                                                                                       //
    if (Meteor.settings["public"].allowUninvited) return true; // all accounts qualify                                 // 1072
                                                                                                                       //
    if (user.signupKey) return true; // user is invited                                                                // 1074
                                                                                                                       //
    if (this.isUserInOrganization(user)) return true;                                                                  // 1076
                                                                                                                       //
    return false;                                                                                                      // 1078
  },                                                                                                                   // 1079
  isSignedUpOrDemo: function isSignedUpOrDemo() {                                                                      // 1081
    var user = Meteor.user();                                                                                          // 1082
    return this.isAccountSignedUpOrDemo(user);                                                                         // 1083
  },                                                                                                                   // 1084
  isAccountSignedUpOrDemo: function isAccountSignedUpOrDemo(user) {                                                    // 1086
    if (!user) return false; // not signed in                                                                          // 1087
                                                                                                                       //
    if (!user.loginIdentities) return false; // not an account                                                         // 1089
                                                                                                                       //
    if (user.expires) return true; // demo user.                                                                       // 1091
                                                                                                                       //
    if (Meteor.settings["public"].allowUninvited) return true; // all accounts qualify                                 // 1093
                                                                                                                       //
    if (user.signupKey) return true; // user is invited                                                                // 1095
                                                                                                                       //
    if (this.isUserInOrganization(user)) return true;                                                                  // 1097
                                                                                                                       //
    return false;                                                                                                      // 1099
  },                                                                                                                   // 1100
  isIdentityInOrganization: function isIdentityInOrganization(identity) {                                              // 1102
    if (!identity || !identity.services) {                                                                             // 1103
      return false;                                                                                                    // 1104
    }                                                                                                                  // 1105
                                                                                                                       //
    var orgMembership = this.getOrganizationMembership();                                                              // 1107
    var googleEnabled = orgMembership && orgMembership.google && orgMembership.google.enabled;                         // 1108
    var googleDomain = orgMembership && orgMembership.google && orgMembership.google.domain;                           // 1109
    var emailEnabled = orgMembership && orgMembership.emailToken && orgMembership.emailToken.enabled;                  // 1110
    var emailDomain = orgMembership && orgMembership.emailToken && orgMembership.emailToken.domain;                    // 1111
    var ldapEnabled = orgMembership && orgMembership.ldap && orgMembership.ldap.enabled;                               // 1112
    var samlEnabled = orgMembership && orgMembership.saml && orgMembership.saml.enabled;                               // 1113
    if (emailEnabled && emailDomain && identity.services.email) {                                                      // 1114
      if (identity.services.email.email.toLowerCase().split("@").pop() === emailDomain) {                              // 1115
        return true;                                                                                                   // 1116
      }                                                                                                                // 1117
    } else if (ldapEnabled && identity.services.ldap) {                                                                // 1118
      return true;                                                                                                     // 1119
    } else if (samlEnabled && identity.services.saml) {                                                                // 1120
      return true;                                                                                                     // 1121
    } else if (googleEnabled && googleDomain && identity.services.google && identity.services.google.hd) {             // 1122
      if (identity.services.google.hd.toLowerCase() === googleDomain) {                                                // 1123
        return true;                                                                                                   // 1124
      }                                                                                                                // 1125
    }                                                                                                                  // 1126
                                                                                                                       //
    return false;                                                                                                      // 1128
  },                                                                                                                   // 1129
  isUserInOrganization: function isUserInOrganization(user) {                                                          // 1131
    if (!this.isFeatureKeyValid()) {                                                                                   // 1132
      return false;                                                                                                    // 1133
    }                                                                                                                  // 1134
                                                                                                                       //
    for (var i = 0; i < user.loginIdentities.length; i++) {                                                            // 1136
      var identity = Meteor.users.findOne({ _id: user.loginIdentities[i].id });                                        // 1137
      if (this.isIdentityInOrganization(identity)) {                                                                   // 1138
        return true;                                                                                                   // 1139
      }                                                                                                                // 1140
    }                                                                                                                  // 1141
                                                                                                                       //
    return false;                                                                                                      // 1143
  }                                                                                                                    // 1144
});                                                                                                                    // 1018
                                                                                                                       //
if (Meteor.isServer) {                                                                                                 // 1147
  (function () {                                                                                                       // 1147
    SandstormDb.prototype.getWildcardOrigin = getWildcardOrigin;                                                       // 1148
                                                                                                                       //
    var Crypto = Npm.require("crypto");                                                                                // 1150
    SandstormDb.prototype.removeApiTokens = function (query) {                                                         // 1151
      var _this2 = this;                                                                                               // 1151
                                                                                                                       //
      // Remove all API tokens matching the query, making sure to clean up ApiHosts as well.                           //
                                                                                                                       //
      this.collections.apiTokens.find(query).forEach(function (token) {                                                // 1154
        // Clean up ApiHosts for webkey tokens.                                                                        //
        if (token.hasApiHost) {                                                                                        // 1156
          var hash2 = Crypto.createHash("sha256").update(token._id).digest("base64");                                  // 1157
          _this2.collections.apiHosts.remove({ hash2: hash2 });                                                        // 1158
        }                                                                                                              // 1159
      });                                                                                                              // 1160
                                                                                                                       //
      this.collections.apiTokens.remove(query);                                                                        // 1162
    };                                                                                                                 // 1163
  })();                                                                                                                // 1147
}                                                                                                                      // 1164
                                                                                                                       //
// TODO(someday): clean this up.  Logic for building static asset urls on client and server                            //
// appears all over the codebase.                                                                                      //
var httpProtocol = void 0;                                                                                             // 1168
if (Meteor.isServer) {                                                                                                 // 1169
  var _Url = Npm.require("url");                                                                                       // 1170
  httpProtocol = _Url.parse(process.env.ROOT_URL).protocol;                                                            // 1171
} else {                                                                                                               // 1172
  httpProtocol = window.location.protocol;                                                                             // 1173
}                                                                                                                      // 1174
                                                                                                                       //
// =======================================================================================                             //
// Below this point are newly-written or refactored functions.                                                         //
                                                                                                                       //
_.extend(SandstormDb.prototype, {                                                                                      // 1179
  getUser: function getUser(userId) {                                                                                  // 1180
    check(userId, Match.OneOf(String, undefined, null));                                                               // 1181
    if (userId) {                                                                                                      // 1182
      return Meteor.users.findOne(userId);                                                                             // 1183
    }                                                                                                                  // 1184
  },                                                                                                                   // 1185
  getIdentity: function getIdentity(identityId) {                                                                      // 1187
    check(identityId, String);                                                                                         // 1188
    var identity = Meteor.users.findOne({ _id: identityId });                                                          // 1189
    if (identity) {                                                                                                    // 1190
      SandstormDb.fillInProfileDefaults(identity);                                                                     // 1191
      SandstormDb.fillInIntrinsicName(identity);                                                                       // 1192
      SandstormDb.fillInPictureUrl(identity);                                                                          // 1193
      return identity;                                                                                                 // 1194
    }                                                                                                                  // 1195
  },                                                                                                                   // 1196
  userHasIdentity: function userHasIdentity(userId, identityId) {                                                      // 1198
    check(userId, String);                                                                                             // 1199
    check(identityId, String);                                                                                         // 1200
                                                                                                                       //
    if (userId === identityId) return true;                                                                            // 1202
                                                                                                                       //
    var user = Meteor.users.findOne(userId);                                                                           // 1204
    return SandstormDb.getUserIdentityIds(user).indexOf(identityId) != -1;                                             // 1205
  },                                                                                                                   // 1206
  userGrains: function userGrains(userId, options) {                                                                   // 1208
    check(userId, Match.OneOf(String, undefined, null));                                                               // 1209
    check(options, Match.OneOf(undefined, null, { includeTrashOnly: Match.Optional(Boolean), includeTrash: Match.Optional(Boolean) }));
                                                                                                                       //
    var query = { userId: userId };                                                                                    // 1213
    if (options && options.includeTrashOnly) {                                                                         // 1214
      query.trashed = { $exists: true };                                                                               // 1215
    } else if (options && options.includeTrash) {                                                                      // 1216
      // Keep query as-is.                                                                                             //
    } else {                                                                                                           // 1218
        query.trashed = { $exists: false };                                                                            // 1219
      }                                                                                                                // 1220
                                                                                                                       //
    return this.collections.grains.find(query);                                                                        // 1222
  },                                                                                                                   // 1223
  currentUserGrains: function currentUserGrains(options) {                                                             // 1225
    return this.userGrains(Meteor.userId(), options);                                                                  // 1226
  },                                                                                                                   // 1227
  getGrain: function getGrain(grainId) {                                                                               // 1229
    check(grainId, String);                                                                                            // 1230
    return this.collections.grains.findOne(grainId);                                                                   // 1231
  },                                                                                                                   // 1232
  userApiTokens: function userApiTokens(userId, trashed) {                                                             // 1234
    check(userId, Match.OneOf(String, undefined, null));                                                               // 1235
    check(trashed, Match.OneOf(Boolean, undefined, null));                                                             // 1236
    var identityIds = SandstormDb.getUserIdentityIds(this.getUser(userId));                                            // 1237
    return this.collections.apiTokens.find({                                                                           // 1238
      "owner.user.identityId": { $in: identityIds },                                                                   // 1239
      trashed: { $exists: !!trashed }                                                                                  // 1240
    });                                                                                                                // 1238
  },                                                                                                                   // 1242
  currentUserApiTokens: function currentUserApiTokens(trashed) {                                                       // 1244
    return this.userApiTokens(Meteor.userId(), trashed);                                                               // 1245
  },                                                                                                                   // 1246
  userActions: function userActions(user) {                                                                            // 1248
    return this.collections.userActions.find({ userId: user });                                                        // 1249
  },                                                                                                                   // 1250
  currentUserActions: function currentUserActions() {                                                                  // 1252
    return this.userActions(Meteor.userId());                                                                          // 1253
  },                                                                                                                   // 1254
  iconSrcForPackage: function iconSrcForPackage(pkg, usage) {                                                          // 1256
    return Identicon.iconSrcForPackage(pkg, usage, httpProtocol + "//" + this.makeWildcardHost("static"));             // 1257
  },                                                                                                                   // 1258
  getDenormalizedGrainInfo: function getDenormalizedGrainInfo(grainId) {                                               // 1260
    var grain = this.getGrain(grainId);                                                                                // 1261
    var pkg = this.collections.packages.findOne(grain.packageId);                                                      // 1262
                                                                                                                       //
    if (!pkg) {                                                                                                        // 1264
      pkg = this.collections.devPackages.findOne(grain.packageId);                                                     // 1265
    }                                                                                                                  // 1266
                                                                                                                       //
    var appTitle = pkg && pkg.manifest && pkg.manifest.appTitle || { defaultText: "" };                                // 1268
    var grainInfo = { appTitle: appTitle };                                                                            // 1269
                                                                                                                       //
    if (pkg && pkg.manifest && pkg.manifest.metadata && pkg.manifest.metadata.icons) {                                 // 1271
      var icons = pkg.manifest.metadata.icons;                                                                         // 1272
      var icon = icons.grain || icons.appGrid;                                                                         // 1273
      if (icon) {                                                                                                      // 1274
        grainInfo.icon = icon;                                                                                         // 1275
      }                                                                                                                // 1276
    }                                                                                                                  // 1277
                                                                                                                       //
    // Only provide an app ID if we have no icon asset to provide and need to offer an identicon.                      //
    if (!grainInfo.icon && pkg) {                                                                                      // 1280
      grainInfo.appId = pkg.appId;                                                                                     // 1281
    }                                                                                                                  // 1282
                                                                                                                       //
    return grainInfo;                                                                                                  // 1284
  },                                                                                                                   // 1285
  getPlan: function getPlan(id, user) {                                                                                // 1287
    check(id, String);                                                                                                 // 1288
                                                                                                                       //
    // `user`, if provided, is the user observing the plan. This matters only for checking if the                      //
    // user is in an experiment.                                                                                       //
                                                                                                                       //
    var plan = this.collections.plans.findOne(id);                                                                     // 1293
    if (!plan) {                                                                                                       // 1294
      throw new Error("no such plan: " + id);                                                                          // 1295
    }                                                                                                                  // 1296
                                                                                                                       //
    if (plan._id === "free") {                                                                                         // 1298
      user = user || Meteor.user();                                                                                    // 1299
      if (user && user.experiments && typeof user.experiments.freeGrainLimit === "number") {                           // 1300
        plan.grains = user.experiments.freeGrainLimit;                                                                 // 1302
      }                                                                                                                // 1303
    }                                                                                                                  // 1304
                                                                                                                       //
    return plan;                                                                                                       // 1306
  },                                                                                                                   // 1307
  listPlans: function listPlans(user) {                                                                                // 1309
    user = user || Meteor.user();                                                                                      // 1310
    if (user && user.experiments && typeof user.experiments.freeGrainLimit === "number") {                             // 1311
      return this.collections.plans.find({}, { sort: { price: 1 } }).map(function (plan) {                             // 1313
        if (plan._id === "free") {                                                                                     // 1315
          plan.grains = user.experiments.freeGrainLimit;                                                               // 1316
        }                                                                                                              // 1317
                                                                                                                       //
        return plan;                                                                                                   // 1319
      });                                                                                                              // 1320
    } else {                                                                                                           // 1321
      return this.collections.plans.find({}, { sort: { price: 1 } }).fetch();                                          // 1322
    }                                                                                                                  // 1323
  },                                                                                                                   // 1324
  getMyPlan: function getMyPlan() {                                                                                    // 1326
    var user = Meteor.user();                                                                                          // 1327
    return user && this.collections.plans.findOne(user.plan || "free");                                                // 1328
  },                                                                                                                   // 1329
  getMyReferralBonus: function getMyReferralBonus(user) {                                                              // 1331
    // This function is called from the server and from the client, similar to getMyPlan().                            //
    //                                                                                                                 //
    // The parameter may be omitted in which case the current user is assumed.                                         //
                                                                                                                       //
    return calculateReferralBonus(user || Meteor.user());                                                              // 1336
  },                                                                                                                   // 1337
  getMyUsage: function getMyUsage(user) {                                                                              // 1339
    user = user || Meteor.user();                                                                                      // 1340
    if (user && (Meteor.isServer || user.pseudoUsage)) {                                                               // 1341
      if (Meteor.isClient) {                                                                                           // 1342
        // Filled by pseudo-subscription to "getMyUsage". WARNING: The subscription is currently                       //
        // not reactive.                                                                                               //
        return user.pseudoUsage;                                                                                       // 1345
      } else {                                                                                                         // 1346
        return {                                                                                                       // 1347
          grains: this.collections.grains.find({ userId: user._id }).count(),                                          // 1348
          storage: user.storageUsage || 0,                                                                             // 1349
          compute: 0 };                                                                                                // 1350
      }                                                                                                                // 1352
    } else // not tracked yet                                                                                          // 1353
      {                                                                                                                // 1353
        return { grains: 0, storage: 0, compute: 0 };                                                                  // 1354
      }                                                                                                                // 1355
  },                                                                                                                   // 1356
  isUninvitedFreeUser: function isUninvitedFreeUser() {                                                                // 1358
    if (!Meteor.settings["public"].allowUninvited) return false;                                                       // 1359
                                                                                                                       //
    var user = Meteor.user();                                                                                          // 1361
    return user && !user.expires && (!user.plan || user.plan === "free");                                              // 1362
  },                                                                                                                   // 1363
  getSetting: function getSetting(name) {                                                                              // 1365
    var setting = this.collections.settings.findOne(name);                                                             // 1366
    return setting && setting.value;                                                                                   // 1367
  },                                                                                                                   // 1368
  getSettingWithFallback: function getSettingWithFallback(name, fallbackValue) {                                       // 1370
    var value = this.getSetting(name);                                                                                 // 1371
    if (value === undefined) {                                                                                         // 1372
      return fallbackValue;                                                                                            // 1373
    }                                                                                                                  // 1374
                                                                                                                       //
    return value;                                                                                                      // 1376
  },                                                                                                                   // 1377
  addUserActions: function addUserActions(userId, packageId, simulation) {                                             // 1379
    check(userId, String);                                                                                             // 1380
    check(packageId, String);                                                                                          // 1381
                                                                                                                       //
    var pack = this.collections.packages.findOne({ _id: packageId });                                                  // 1383
    if (pack) {                                                                                                        // 1384
      // Remove old versions.                                                                                          //
      var numRemoved = this.collections.userActions.remove({ userId: userId, appId: pack.appId });                     // 1386
                                                                                                                       //
      // Install new.                                                                                                  //
      var actions = pack.manifest.actions;                                                                             // 1389
      for (var i in actions) {                                                                                         // 1390
        var action = actions[i];                                                                                       // 1391
        if ("none" in action.input) {                                                                                  // 1392
          var userAction = {                                                                                           // 1393
            userId: userId,                                                                                            // 1394
            packageId: pack._id,                                                                                       // 1395
            appId: pack.appId,                                                                                         // 1396
            appTitle: pack.manifest.appTitle,                                                                          // 1397
            appMarketingVersion: pack.manifest.appMarketingVersion,                                                    // 1398
            appVersion: pack.manifest.appVersion,                                                                      // 1399
            title: action.title,                                                                                       // 1400
            nounPhrase: action.nounPhrase,                                                                             // 1401
            command: action.command                                                                                    // 1402
          };                                                                                                           // 1393
          this.collections.userActions.insert(userAction);                                                             // 1404
        } else {                                                                                                       // 1405
          // TODO(someday):  Implement actions with capability inputs.                                                 //
        }                                                                                                              // 1407
      }                                                                                                                // 1408
                                                                                                                       //
      if (numRemoved > 0 && !simulation) {                                                                             // 1410
        this.deleteUnusedPackages(pack.appId);                                                                         // 1411
      }                                                                                                                // 1412
    }                                                                                                                  // 1413
  },                                                                                                                   // 1414
  sendAdminNotification: function sendAdminNotification(type, action) {                                                // 1416
    Meteor.users.find({ isAdmin: true }, { fields: { _id: 1 } }).forEach(function (user) {                             // 1417
      Notifications.insert({                                                                                           // 1418
        admin: { action: action, type: type },                                                                         // 1419
        userId: user._id,                                                                                              // 1420
        timestamp: new Date(),                                                                                         // 1421
        isUnread: true                                                                                                 // 1422
      });                                                                                                              // 1418
    });                                                                                                                // 1424
  },                                                                                                                   // 1425
  getKeybaseProfile: function getKeybaseProfile(keyFingerprint) {                                                      // 1427
    return this.collections.keybaseProfiles.findOne(keyFingerprint) || {};                                             // 1428
  },                                                                                                                   // 1429
  getServerTitle: function getServerTitle() {                                                                          // 1431
    var setting = this.collections.settings.findOne({ _id: "serverTitle" });                                           // 1432
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1433
  },                                                                                                                   // 1434
  getSmtpConfig: function getSmtpConfig() {                                                                            // 1436
    var setting = this.collections.settings.findOne({ _id: "smtpConfig" });                                            // 1437
    return setting ? setting.value : undefined; // undefined if subscription is not ready.                             // 1438
  },                                                                                                                   // 1439
  getReturnAddress: function getReturnAddress() {                                                                      // 1441
    var config = this.getSmtpConfig();                                                                                 // 1442
    return config && config.returnAddress || ""; // empty if subscription is not ready.                                // 1443
  },                                                                                                                   // 1444
  getReturnAddressWithDisplayName: function getReturnAddressWithDisplayName(identityId) {                              // 1446
    check(identityId, String);                                                                                         // 1447
    var identity = this.getIdentity(identityId);                                                                       // 1448
    var displayName = identity.profile.name + " (via " + this.getServerTitle() + ")";                                  // 1449
                                                                                                                       //
    // First remove any instances of characters that cause trouble for SimpleSmtp. Ideally,                            //
    // we could escape such characters with a backslash, but that does not seem to help here.                          //
    var sanitized = displayName.replace(/"|<|>|\\|\r/g, "");                                                           // 1453
                                                                                                                       //
    return "\"" + sanitized + "\" <" + this.getReturnAddress() + ">";                                                  // 1455
  },                                                                                                                   // 1456
  getPrimaryEmail: function getPrimaryEmail(accountId, identityId) {                                                   // 1458
    check(accountId, String);                                                                                          // 1459
    check(identityId, String);                                                                                         // 1460
                                                                                                                       //
    var identity = this.getIdentity(identityId);                                                                       // 1462
    var senderEmails = SandstormDb.getVerifiedEmails(identity);                                                        // 1463
    var senderPrimaryEmail = _.findWhere(senderEmails, { primary: true });                                             // 1464
    var accountPrimaryEmailAddress = this.getUser(accountId).primaryEmail;                                             // 1465
    if (_.findWhere(senderEmails, { email: accountPrimaryEmailAddress })) {                                            // 1466
      return accountPrimaryEmailAddress;                                                                               // 1467
    } else if (senderPrimaryEmail) {                                                                                   // 1468
      return senderPrimaryEmail.email;                                                                                 // 1469
    } else {                                                                                                           // 1470
      return null;                                                                                                     // 1471
    }                                                                                                                  // 1472
  },                                                                                                                   // 1473
  incrementDailySentMailCount: function incrementDailySentMailCount(accountId) {                                       // 1475
    check(accountId, String);                                                                                          // 1476
                                                                                                                       //
    var DAILY_LIMIT = 50;                                                                                              // 1478
    var result = Meteor.users.findAndModify({                                                                          // 1479
      query: { _id: accountId },                                                                                       // 1480
      update: {                                                                                                        // 1481
        $inc: {                                                                                                        // 1482
          dailySentMailCount: 1                                                                                        // 1483
        }                                                                                                              // 1482
      },                                                                                                               // 1481
      fields: { dailySentMailCount: 1 }                                                                                // 1486
    });                                                                                                                // 1479
                                                                                                                       //
    if (!result.ok) {                                                                                                  // 1489
      throw new Error("Couldn't update daily sent mail count.");                                                       // 1490
    }                                                                                                                  // 1491
                                                                                                                       //
    var user = result.value;                                                                                           // 1493
    if (user.dailySentMailCount >= DAILY_LIMIT) {                                                                      // 1494
      throw new Error("Sorry, you've reached your e-mail sending limit for today. Currently, Sandstorm " + "limits each user to " + DAILY_LIMIT + " e-mails per day for spam control reasons. " + "Please feel free to contact us if this is a problem.");
    }                                                                                                                  // 1499
  },                                                                                                                   // 1500
  isFeatureKeyValid: function isFeatureKeyValid() {                                                                    // 1502
    var featureKey = this.currentFeatureKey();                                                                         // 1503
    return !!featureKey;                                                                                               // 1504
  },                                                                                                                   // 1505
  isFeatureKeyValidAndNotExpired: function isFeatureKeyValidAndNotExpired() {                                          // 1507
    var featureKey = this.currentFeatureKey();                                                                         // 1508
    return featureKey && parseInt(featureKey.expires) > Date.now() / 1000;                                             // 1509
  },                                                                                                                   // 1510
  isFeatureKeyOptedIntoStats: function isFeatureKeyOptedIntoStats() {                                                  // 1512
    var featureKey = this.currentFeatureKey();                                                                         // 1513
    return featureKey && featureKey.isTrial && parseInt(featureKey.issued) > 1472601600;                               // 1514
    // 1472601600 is 2016 Aug 31 in seconds since the epoch                                                            //
  },                                                                                                                   // 1516
  getLdapUrl: function getLdapUrl() {                                                                                  // 1518
    var setting = this.collections.settings.findOne({ _id: "ldapUrl" });                                               // 1519
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1520
  },                                                                                                                   // 1521
  getLdapBase: function getLdapBase() {                                                                                // 1523
    var setting = this.collections.settings.findOne({ _id: "ldapBase" });                                              // 1524
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1525
  },                                                                                                                   // 1526
  getLdapDnPattern: function getLdapDnPattern() {                                                                      // 1528
    var setting = this.collections.settings.findOne({ _id: "ldapDnPattern" });                                         // 1529
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1530
  },                                                                                                                   // 1531
  getLdapSearchUsername: function getLdapSearchUsername() {                                                            // 1533
    var setting = this.collections.settings.findOne({ _id: "ldapSearchUsername" });                                    // 1534
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1535
  },                                                                                                                   // 1536
  getLdapNameField: function getLdapNameField() {                                                                      // 1538
    var setting = this.collections.settings.findOne({ _id: "ldapNameField" });                                         // 1539
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1540
  },                                                                                                                   // 1541
  getLdapEmailField: function getLdapEmailField() {                                                                    // 1543
    var setting = this.collections.settings.findOne({ _id: "ldapEmailField" });                                        // 1544
    return setting ? setting.value : "mail";                                                                           // 1545
    // default to "mail". This setting was added later, and so could potentially be unset.                             //
  },                                                                                                                   // 1547
  getLdapExplicitDnSelected: function getLdapExplicitDnSelected() {                                                    // 1549
    var setting = this.collections.settings.findOne({ _id: "ldapExplicitDnSelected" });                                // 1550
    return setting && setting.value;                                                                                   // 1551
  },                                                                                                                   // 1552
  getLdapFilter: function getLdapFilter() {                                                                            // 1554
    var setting = this.collections.settings.findOne({ _id: "ldapFilter" });                                            // 1555
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1556
  },                                                                                                                   // 1557
  getLdapSearchBindDn: function getLdapSearchBindDn() {                                                                // 1559
    var setting = this.collections.settings.findOne({ _id: "ldapSearchBindDn" });                                      // 1560
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1561
  },                                                                                                                   // 1562
  getLdapSearchBindPassword: function getLdapSearchBindPassword() {                                                    // 1564
    var setting = this.collections.settings.findOne({ _id: "ldapSearchBindPassword" });                                // 1565
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1566
  },                                                                                                                   // 1567
  getLdapCaCert: function getLdapCaCert() {                                                                            // 1569
    var setting = this.collections.settings.findOne({ _id: "ldapCaCert" });                                            // 1570
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1571
  },                                                                                                                   // 1572
  getOrganizationMembership: function getOrganizationMembership() {                                                    // 1574
    var setting = this.collections.settings.findOne({ _id: "organizationMembership" });                                // 1575
    return setting && setting.value;                                                                                   // 1576
  },                                                                                                                   // 1577
  getOrganizationEmailEnabled: function getOrganizationEmailEnabled() {                                                // 1579
    var membership = this.getOrganizationMembership();                                                                 // 1580
    return membership && membership.emailToken && membership.emailToken.enabled;                                       // 1581
  },                                                                                                                   // 1582
  getOrganizationEmailDomain: function getOrganizationEmailDomain() {                                                  // 1584
    var membership = this.getOrganizationMembership();                                                                 // 1585
    return membership && membership.emailToken && membership.emailToken.domain;                                        // 1586
  },                                                                                                                   // 1587
  getOrganizationGoogleEnabled: function getOrganizationGoogleEnabled() {                                              // 1589
    var membership = this.getOrganizationMembership();                                                                 // 1590
    return membership && membership.google && membership.google.enabled;                                               // 1591
  },                                                                                                                   // 1592
  getOrganizationGoogleDomain: function getOrganizationGoogleDomain() {                                                // 1594
    var membership = this.getOrganizationMembership();                                                                 // 1595
    return membership && membership.google && membership.google.domain;                                                // 1596
  },                                                                                                                   // 1597
  getOrganizationLdapEnabled: function getOrganizationLdapEnabled() {                                                  // 1599
    var membership = this.getOrganizationMembership();                                                                 // 1600
    return membership && membership.ldap && membership.ldap.enabled;                                                   // 1601
  },                                                                                                                   // 1602
  getOrganizationSamlEnabled: function getOrganizationSamlEnabled() {                                                  // 1604
    var membership = this.getOrganizationMembership();                                                                 // 1605
    return membership && membership.saml && membership.saml.enabled;                                                   // 1606
  },                                                                                                                   // 1607
  getOrganizationDisallowGuests: function getOrganizationDisallowGuests() {                                            // 1609
    return this.getOrganizationDisallowGuestsRaw() && this.isFeatureKeyValid();                                        // 1610
  },                                                                                                                   // 1611
  getOrganizationDisallowGuestsRaw: function getOrganizationDisallowGuestsRaw() {                                      // 1613
    var setting = this.collections.settings.findOne({ _id: "organizationSettings" });                                  // 1614
    return setting && setting.value && setting.value.disallowGuests;                                                   // 1615
  },                                                                                                                   // 1616
  getOrganizationShareContacts: function getOrganizationShareContacts() {                                              // 1618
    return this.getOrganizationShareContactsRaw() && this.isFeatureKeyValid();                                         // 1619
  },                                                                                                                   // 1620
  getOrganizationShareContactsRaw: function getOrganizationShareContactsRaw() {                                        // 1622
    var setting = this.collections.settings.findOne({ _id: "organizationSettings" });                                  // 1623
    if (!setting || !setting.value || setting.value.shareContacts === undefined) {                                     // 1624
      // default to true if undefined                                                                                  //
      return true;                                                                                                     // 1626
    } else {                                                                                                           // 1627
      return setting.value.shareContacts;                                                                              // 1628
    }                                                                                                                  // 1629
  },                                                                                                                   // 1630
  getSamlEntryPoint: function getSamlEntryPoint() {                                                                    // 1632
    var setting = this.collections.settings.findOne({ _id: "samlEntryPoint" });                                        // 1633
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1634
  },                                                                                                                   // 1635
  getSamlLogout: function getSamlLogout() {                                                                            // 1637
    var setting = this.collections.settings.findOne({ _id: "samlLogout" });                                            // 1638
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1639
  },                                                                                                                   // 1640
  getSamlPublicCert: function getSamlPublicCert() {                                                                    // 1642
    var setting = this.collections.settings.findOne({ _id: "samlPublicCert" });                                        // 1643
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1644
  },                                                                                                                   // 1645
  getSamlEntityId: function getSamlEntityId() {                                                                        // 1647
    var setting = this.collections.settings.findOne({ _id: "samlEntityId" });                                          // 1648
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1649
  },                                                                                                                   // 1650
  userHasSamlLoginIdentity: function userHasSamlLoginIdentity() {                                                      // 1652
    var user = Meteor.user();                                                                                          // 1653
    if (!user.loginIdentities) {                                                                                       // 1654
      return false;                                                                                                    // 1655
    }                                                                                                                  // 1656
                                                                                                                       //
    var hasSaml = false;                                                                                               // 1658
    user.loginIdentities.forEach(function (identity) {                                                                 // 1659
      if (Meteor.users.findOne({ _id: identity.id }).services.saml) {                                                  // 1660
        hasSaml = true;                                                                                                // 1661
      }                                                                                                                // 1662
    });                                                                                                                // 1663
                                                                                                                       //
    return hasSaml;                                                                                                    // 1665
  },                                                                                                                   // 1666
  getActivitySubscriptions: function getActivitySubscriptions(grainId, threadPath) {                                   // 1668
    return this.collections.activitySubscriptions.find({                                                               // 1669
      grainId: grainId,                                                                                                // 1670
      threadPath: threadPath || { $exists: false }                                                                     // 1671
    }, {                                                                                                               // 1669
      fields: { identityId: 1, mute: 1, _id: 0 }                                                                       // 1673
    }).fetch();                                                                                                        // 1672
  },                                                                                                                   // 1675
  subscribeToActivity: function subscribeToActivity(identityId, grainId, threadPath) {                                 // 1677
    // Subscribe the given identity to activity events with the given grainId and (optional)                           //
    // threadPath -- unless the identity has previously muted this grainId/threadPath, in which                        //
    // case do nothing.                                                                                                //
                                                                                                                       //
    var record = { identityId: identityId, grainId: grainId };                                                         // 1682
    if (threadPath) {                                                                                                  // 1683
      record.threadPath = threadPath;                                                                                  // 1684
    }                                                                                                                  // 1685
                                                                                                                       //
    // The $set here is redundant since an upsert automatically initializes a new record to contain                    //
    // the fields from the query, but if we try to do { $set: {} } Mongo throws an exception, and                      //
    // if we try to just pass {}, Mongo interprets it as "replace the record with an empty record".                    //
    // What a wonderful query language.                                                                                //
    this.collections.activitySubscriptions.upsert(record, { $set: record });                                           // 1691
  },                                                                                                                   // 1692
  muteActivity: function muteActivity(identityId, grainId, threadPath) {                                               // 1694
    // Mute notifications for the given identity originating from the given grainId and                                //
    // (optional) threadPath.                                                                                          //
                                                                                                                       //
    var record = { identityId: identityId, grainId: grainId };                                                         // 1698
    if (threadPath) {                                                                                                  // 1699
      record.threadPath = threadPath;                                                                                  // 1700
    }                                                                                                                  // 1701
                                                                                                                       //
    this.collections.activitySubscriptions.upsert(record, { $set: { mute: true } });                                   // 1703
  },                                                                                                                   // 1704
  updateAppIndex: function updateAppIndex() {                                                                          // 1706
    var _this3 = this;                                                                                                 // 1706
                                                                                                                       //
    var appUpdatesEnabledSetting = this.collections.settings.findOne({ _id: "appUpdatesEnabled" });                    // 1707
    var appUpdatesEnabled = appUpdatesEnabledSetting && appUpdatesEnabledSetting.value;                                // 1708
    if (!appUpdatesEnabled) {                                                                                          // 1709
      // It's much simpler to check appUpdatesEnabled here rather than reactively deactivate the                       //
      // timer that triggers this call.                                                                                //
      return;                                                                                                          // 1712
    }                                                                                                                  // 1713
                                                                                                                       //
    var appIndexUrl = this.collections.settings.findOne({ _id: "appIndexUrl" }).value;                                 // 1715
    var appIndex = this.collections.appIndex;                                                                          // 1716
    var data = HTTP.get(appIndexUrl + "/apps/index.json").data;                                                        // 1717
    var preinstalledAppIds = this.getAllPreinstalledAppIds();                                                          // 1718
    // We make sure to get all preinstalled appIds, even ones that are currently                                       //
    // downloading/failed.                                                                                             //
    data.apps.forEach(function (app) {                                                                                 // 1721
      app._id = app.appId;                                                                                             // 1722
                                                                                                                       //
      var oldApp = appIndex.findOne({ _id: app.appId });                                                               // 1724
      app.hasSentNotifications = false;                                                                                // 1725
      appIndex.upsert({ _id: app._id }, app);                                                                          // 1726
      var isAppPreinstalled = _.contains(preinstalledAppIds, app.appId);                                               // 1727
      if ((!oldApp || app.versionNumber > oldApp.versionNumber) && (_this3.collections.userActions.findOne({ appId: app.appId }) || isAppPreinstalled)) {
        var pack = _this3.collections.packages.findOne({ _id: app.packageId });                                        // 1731
        var url = appIndexUrl + "/packages/" + app.packageId;                                                          // 1732
        if (pack) {                                                                                                    // 1733
          if (pack.status === "ready") {                                                                               // 1734
            if (pack.appId && pack.appId !== app.appId) {                                                              // 1735
              console.error("app index returned app ID and package ID that don't match:", JSON.stringify(app));        // 1736
            } else {                                                                                                   // 1738
              _this3.sendAppUpdateNotifications(app.appId, app.packageId, app.name, app.versionNumber, app.version);   // 1739
              if (isAppPreinstalled) {                                                                                 // 1741
                _this3.setPreinstallAppAsReady(app.appId, app.packageId);                                              // 1742
              }                                                                                                        // 1743
            }                                                                                                          // 1744
          } else {                                                                                                     // 1745
            var result = _this3.collections.packages.findAndModify({                                                   // 1746
              query: { _id: app.packageId },                                                                           // 1747
              update: { $set: { isAutoUpdated: true } }                                                                // 1748
            });                                                                                                        // 1746
                                                                                                                       //
            if (!result.ok) {                                                                                          // 1751
              return;                                                                                                  // 1752
            }                                                                                                          // 1753
                                                                                                                       //
            var newPack = result.value;                                                                                // 1755
            if (newPack.status === "ready") {                                                                          // 1756
              // The package was marked as ready before we applied isAutoUpdated=true. We should send                  //
              // notifications ourselves to be sure there's no timing issue (sending more than one is                  //
              // fine, since it will de-dupe).                                                                         //
              if (pack.appId && pack.appId !== app.appId) {                                                            // 1760
                console.error("app index returned app ID and package ID that don't match:", JSON.stringify(app));      // 1761
              } else {                                                                                                 // 1763
                _this3.sendAppUpdateNotifications(app.appId, app.packageId, app.name, app.versionNumber, app.version);
                if (isAppPreinstalled) {                                                                               // 1766
                  _this3.setPreinstallAppAsReady(app.appId, app.packageId);                                            // 1767
                }                                                                                                      // 1768
              }                                                                                                        // 1769
            } else if (newPack.status === "failed") {                                                                  // 1770
              // If the package has failed, retry it                                                                   //
              _this3.startInstall(app.packageId, url, true, true);                                                     // 1772
            }                                                                                                          // 1773
          }                                                                                                            // 1774
        } else {                                                                                                       // 1775
          _this3.startInstall(app.packageId, url, false, true);                                                        // 1776
        }                                                                                                              // 1777
      }                                                                                                                // 1778
    });                                                                                                                // 1779
  },                                                                                                                   // 1780
  isPackagePreinstalled: function isPackagePreinstalled(packageId) {                                                   // 1782
    return this.collections.settings.find({ _id: "preinstalledApps", "value.packageId": packageId }).count() === 1;    // 1783
  },                                                                                                                   // 1784
  getAppIdForPreinstalledPackage: function getAppIdForPreinstalledPackage(packageId) {                                 // 1786
    var setting = this.collections.settings.findOne({ _id: "preinstalledApps", "value.packageId": packageId }, { fields: { "value.$": 1 } });
    // value.$ causes mongo to transform the result and only return the first matching element in                      //
    // the array                                                                                                       //
    return setting && setting.value && setting.value[0] && setting.value[0].appId;                                     // 1791
  },                                                                                                                   // 1792
  getPackageIdForPreinstalledApp: function getPackageIdForPreinstalledApp(appId) {                                     // 1794
    var setting = this.collections.settings.findOne({ _id: "preinstalledApps", "value.appId": appId }, { fields: { "value.$": 1 } });
    // value.$ causes mongo to transform the result and only return the first matching element in                      //
    // the array                                                                                                       //
    return setting && setting.value && setting.value[0] && setting.value[0].packageId;                                 // 1799
  },                                                                                                                   // 1800
  getReadyPreinstalledAppIds: function getReadyPreinstalledAppIds() {                                                  // 1802
    var setting = this.collections.settings.findOne({ _id: "preinstalledApps" });                                      // 1803
    var ret = setting && setting.value || [];                                                                          // 1804
    return _.chain(ret).filter(function (app) {                                                                        // 1805
      return app.status === "ready";                                                                                   // 1806
    }).map(function (app) {                                                                                            // 1806
      return app.appId;                                                                                                // 1807
    }).value();                                                                                                        // 1807
  },                                                                                                                   // 1809
  getAllPreinstalledAppIds: function getAllPreinstalledAppIds() {                                                      // 1811
    var setting = this.collections.settings.findOne({ _id: "preinstalledApps" });                                      // 1812
    var ret = setting && setting.value || [];                                                                          // 1813
    return _.map(ret, function (app) {                                                                                 // 1814
      return app.appId;                                                                                                // 1814
    });                                                                                                                // 1814
  },                                                                                                                   // 1815
  preinstallAppsForUser: function preinstallAppsForUser(userId) {                                                      // 1817
    var _this4 = this;                                                                                                 // 1817
                                                                                                                       //
    var appIds = this.getReadyPreinstalledAppIds();                                                                    // 1818
    appIds.forEach(function (appId) {                                                                                  // 1819
      try {                                                                                                            // 1820
        _this4.addUserActions(userId, _this4.getPackageIdForPreinstalledApp(appId));                                   // 1821
      } catch (e) {                                                                                                    // 1822
        console.error("failed to install app for user:", e);                                                           // 1823
      }                                                                                                                // 1824
    });                                                                                                                // 1825
  },                                                                                                                   // 1826
  setPreinstallAppAsDownloading: function setPreinstallAppAsDownloading(appId, packageId) {                            // 1828
    this.collections.settings.update({ _id: "preinstalledApps", "value.appId": appId, "value.packageId": packageId }, { $set: { "value.$.status": "downloading" } });
  },                                                                                                                   // 1832
  setPreinstallAppAsReady: function setPreinstallAppAsReady(appId, packageId) {                                        // 1834
    // This function both sets the appId as ready and updates the packageId for the given appId                        //
    // Setting the packageId is especially useful in installer.js, as it always ensures the                            //
    // latest installed package will be set as ready.                                                                  //
    this.collections.settings.update({ _id: "preinstalledApps", "value.appId": appId }, { $set: { "value.$.status": "ready", "value.$.packageId": packageId } });
  },                                                                                                                   // 1841
  ensureAppPreinstall: function ensureAppPreinstall(appId, packageId) {                                                // 1843
    check(appId, String);                                                                                              // 1844
    var appIndexUrl = this.collections.settings.findOne({ _id: "appIndexUrl" }).value;                                 // 1845
    var pack = this.collections.packages.findOne({ _id: packageId });                                                  // 1846
    var url = appIndexUrl + "/packages/" + packageId;                                                                  // 1847
    if (pack && pack.status === "ready") {                                                                             // 1848
      this.setPreinstallAppAsReady(appId, packageId);                                                                  // 1849
    } else if (pack && pack.status === "failed") {                                                                     // 1850
      this.setPreinstallAppAsDownloading(appId, packageId);                                                            // 1851
      this.startInstall(packageId, url, true, false);                                                                  // 1852
    } else {                                                                                                           // 1853
      this.setPreinstallAppAsDownloading(appId, packageId);                                                            // 1854
      this.startInstall(packageId, url, false, false);                                                                 // 1855
    }                                                                                                                  // 1856
  },                                                                                                                   // 1857
  setPreinstalledApps: function setPreinstalledApps(appAndPackageIds) {                                                // 1859
    var _this5 = this;                                                                                                 // 1859
                                                                                                                       //
    // appAndPackageIds: A List[Object] where each element has fields:                                                 //
    //     appId: The Packages.appId of the app to install                                                             //
    //     packageId: The Packages._id of the app to install                                                           //
    check(appAndPackageIds, [{ appId: String, packageId: String }]);                                                   // 1863
                                                                                                                       //
    // Start by clearing out the setting. We'll push appIds one by one to it                                           //
    this.collections.settings.upsert({ _id: "preinstalledApps" }, { $set: {                                            // 1866
        value: appAndPackageIds.map(function (data) {                                                                  // 1867
          return {                                                                                                     // 1868
            appId: data.appId,                                                                                         // 1869
            status: "notReady",                                                                                        // 1870
            packageId: data.packageId                                                                                  // 1871
          };                                                                                                           // 1868
        })                                                                                                             // 1873
      } });                                                                                                            // 1866
    appAndPackageIds.forEach(function (data) {                                                                         // 1875
      _this5.ensureAppPreinstall(data.appId, data.packageId);                                                          // 1876
    });                                                                                                                // 1877
  },                                                                                                                   // 1878
  getProductivitySuiteAppIds: function getProductivitySuiteAppIds() {                                                  // 1880
    return ["8aspz4sfjnp8u89000mh2v1xrdyx97ytn8hq71mdzv4p4d8n0n3h", // Davros                                          // 1881
    "h37dm17aa89yrd8zuqpdn36p6zntumtv08fjpu8a8zrte7q1cn60", // Etherpad                                                // 1883
    "vfnwptfn02ty21w715snyyczw0nqxkv3jvawcah10c6z7hj1hnu0", // Rocket.Chat                                             // 1884
    "m86q05rdvj14yvn78ghaxynqz7u2svw6rnttptxx49g1785cdv1h"];                                                           // 1885
  },                                                                                                                   // 1887
  // Wekan                                                                                                             //
  getSystemSuiteAppIds: function getSystemSuiteAppIds() {                                                              // 1889
    return ["s3u2xgmqwznz2n3apf30sm3gw1d85y029enw5pymx734cnk5n78h"];                                                   // 1890
  },                                                                                                                   // 1893
  // Collections                                                                                                       //
  isPreinstalledAppsReady: function isPreinstalledAppsReady() {                                                        // 1895
    var setting = this.collections.settings.findOne({ _id: "preinstalledApps" });                                      // 1896
    if (!setting || !setting.value) {                                                                                  // 1897
      return true;                                                                                                     // 1898
    }                                                                                                                  // 1899
                                                                                                                       //
    var packageIds = _.pluck(setting.value, "packageId");                                                              // 1901
    var readyApps = this.collections.packages.find({                                                                   // 1902
      _id: {                                                                                                           // 1903
        $in: packageIds                                                                                                // 1904
      },                                                                                                               // 1903
      status: "ready"                                                                                                  // 1906
    });                                                                                                                // 1902
    return readyApps.count() === packageIds.length;                                                                    // 1908
  },                                                                                                                   // 1909
  getBillingPromptUrl: function getBillingPromptUrl() {                                                                // 1911
    var setting = this.collections.settings.findOne({ _id: "billingPromptUrl" });                                      // 1912
    return setting && setting.value;                                                                                   // 1913
  },                                                                                                                   // 1914
  isReferralEnabled: function isReferralEnabled() {                                                                    // 1916
    // This function is a bit weird, in that we've transitioned from                                                   //
    // Meteor.settings.public.quotaEnabled to DB settings. For now,                                                    //
    // Meteor.settings.public.quotaEnabled implies bothisReferralEnabled and isQuotaEnabled are true.                  //
    return Meteor.settings["public"].quotaEnabled;                                                                     // 1920
  },                                                                                                                   // 1921
  isHideAboutEnabled: function isHideAboutEnabled() {                                                                  // 1923
    var setting = this.collections.settings.findOne({ _id: "whiteLabelHideAbout" });                                   // 1924
    return setting && setting.value && this.isFeatureKeyValid();                                                       // 1925
  },                                                                                                                   // 1926
  isQuotaEnabled: function isQuotaEnabled() {                                                                          // 1928
    if (Meteor.settings["public"].quotaEnabled) return true;                                                           // 1929
                                                                                                                       //
    var setting = this.collections.settings.findOne({ _id: "quotaEnabled" });                                          // 1931
    return setting && setting.value && this.isFeatureKeyValid();                                                       // 1932
  },                                                                                                                   // 1933
  isQuotaLdapEnabled: function isQuotaLdapEnabled() {                                                                  // 1935
    var setting = this.collections.settings.findOne({ _id: "quotaLdapEnabled" });                                      // 1936
    return setting && setting.value && this.isFeatureKeyValid();                                                       // 1937
  },                                                                                                                   // 1938
  updateUserQuota: function updateUserQuota(user) {                                                                    // 1940
    if (this.quotaManager) {                                                                                           // 1941
      return this.quotaManager.updateUserQuota(this, user);                                                            // 1942
    }                                                                                                                  // 1943
  },                                                                                                                   // 1944
  getUserQuota: function getUserQuota(user) {                                                                          // 1946
    if (this.isQuotaLdapEnabled()) {                                                                                   // 1947
      return this.quotaManager.updateUserQuota(this, user);                                                            // 1948
    } else {                                                                                                           // 1949
      var plan = this.getPlan(user.plan || "free", user);                                                              // 1950
      var referralBonus = calculateReferralBonus(user);                                                                // 1951
      var bonus = user.planBonus || {};                                                                                // 1952
      var userQuota = {                                                                                                // 1953
        storage: plan.storage + referralBonus.storage + (bonus.storage || 0),                                          // 1954
        grains: plan.grains + referralBonus.grains + (bonus.grains || 0),                                              // 1955
        compute: plan.compute + (bonus.compute || 0)                                                                   // 1956
      };                                                                                                               // 1953
      return userQuota;                                                                                                // 1958
    }                                                                                                                  // 1959
  },                                                                                                                   // 1960
  isUserOverQuota: function isUserOverQuota(user) {                                                                    // 1962
    // Return false if user has quota space remaining, true if it is full. When this returns true,                     //
    // we will not allow the user to create new grains, though they may be able to open existing ones                  //
    // which may still increase their storage usage.                                                                   //
    //                                                                                                                 //
    // (Actually returns a string which can be fed into `billingPrompt` as the reason.)                                //
                                                                                                                       //
    if (!this.isQuotaEnabled() || user.isAdmin) return false;                                                          // 1969
                                                                                                                       //
    var plan = this.getUserQuota(user);                                                                                // 1971
    if (plan.grains < Infinity) {                                                                                      // 1972
      var count = this.collections.grains.find({ userId: user._id, trashed: { $exists: false } }, { fields: {}, limit: plan.grains }).count();
      if (count >= plan.grains) return "outOfGrains";                                                                  // 1975
    }                                                                                                                  // 1976
                                                                                                                       //
    return plan && user.storageUsage && user.storageUsage >= plan.storage && "outOfStorage";                           // 1978
  },                                                                                                                   // 1979
  isUserExcessivelyOverQuota: function isUserExcessivelyOverQuota(user) {                                              // 1981
    // Return true if user is so far over quota that we should prevent their existing grains from                      //
    // running at all.                                                                                                 //
    //                                                                                                                 //
    // (Actually returns a string which can be fed into `billingPrompt` as the reason.)                                //
                                                                                                                       //
    if (!this.isQuotaEnabled() || user.isAdmin) return false;                                                          // 1987
                                                                                                                       //
    var quota = this.getUserQuota(user);                                                                               // 1989
                                                                                                                       //
    // quota.grains = Infinity means unlimited grains. IEEE754 defines Infinity == Infinity.                           //
    if (quota.grains < Infinity) {                                                                                     // 1992
      var count = this.collections.grains.find({ userId: user._id, trashed: { $exists: false } }, { fields: {}, limit: quota.grains * 2 }).count();
      if (count >= quota.grains * 2) return "outOfGrains";                                                             // 1995
    }                                                                                                                  // 1996
                                                                                                                       //
    return quota && user.storageUsage && user.storageUsage >= quota.storage * 1.2 && "outOfStorage";                   // 1998
  },                                                                                                                   // 1999
  suspendIdentity: function suspendIdentity(userId, suspension) {                                                      // 2001
    check(userId, String);                                                                                             // 2002
    check(suspension, {                                                                                                // 2003
      timestamp: Date,                                                                                                 // 2004
      admin: Match.Optional(String),                                                                                   // 2005
      voluntary: Match.Optional(Boolean)                                                                               // 2006
    });                                                                                                                // 2003
                                                                                                                       //
    this.collections.users.update({ _id: userId }, { $set: { suspended: suspension } });                               // 2009
    this.collections.apiTokens.update({ "owner.user.identityId": userId }, { $set: { suspended: true } }, { multi: true });
  },                                                                                                                   // 2012
  unsuspendIdentity: function unsuspendIdentity(userId) {                                                              // 2014
    check(userId, String);                                                                                             // 2015
                                                                                                                       //
    this.collections.users.update({ _id: userId }, { $unset: { suspended: 1 } });                                      // 2017
    this.collections.apiTokens.update({ "owner.user.identityId": userId }, { $unset: { suspended: true } }, { multi: true });
  },                                                                                                                   // 2020
  suspendAccount: function suspendAccount(userId, byAdminUserId, willDelete) {                                         // 2022
    var _this6 = this;                                                                                                 // 2022
                                                                                                                       //
    check(userId, String);                                                                                             // 2023
    check(byAdminUserId, Match.OneOf(String, null, undefined));                                                        // 2024
    check(willDelete, Boolean);                                                                                        // 2025
                                                                                                                       //
    var user = this.collections.users.findOne({ _id: userId });                                                        // 2027
    var suspension = {                                                                                                 // 2028
      timestamp: new Date(),                                                                                           // 2029
      willDelete: willDelete || false                                                                                  // 2030
    };                                                                                                                 // 2028
    if (byAdminUserId) {                                                                                               // 2032
      suspension.admin = byAdminUserId;                                                                                // 2033
    } else {                                                                                                           // 2034
      suspension.voluntary = true;                                                                                     // 2035
    }                                                                                                                  // 2036
                                                                                                                       //
    this.collections.users.update({ _id: userId }, { $set: { suspended: suspension } });                               // 2038
    this.collections.grains.update({ userId: userId }, { $set: { suspended: true } }, { multi: true });                // 2039
                                                                                                                       //
    delete suspension.willDelete;                                                                                      // 2041
    // Only mark the parent account for deletion. This makes the query simpler later.                                  //
                                                                                                                       //
    user.loginIdentities.forEach(function (identity) {                                                                 // 2044
      _this6.suspendIdentity(identity.id, suspension);                                                                 // 2045
    });                                                                                                                // 2046
    user.nonloginIdentities.forEach(function (identity) {                                                              // 2047
      if (_this6.collections.users.find({ $or: [{ "loginIdentities.id": identity.id }, { "nonloginIdentities.id": identity.id }] }).count() === 1) {
        // Only suspend non-login identities that are unique to this account.                                          //
        _this6.suspendIdentity(identity.id, suspension);                                                               // 2053
      }                                                                                                                // 2054
    });                                                                                                                // 2055
                                                                                                                       //
    // Force logout this user                                                                                          //
    this.collections.users.update({ _id: userId }, { $unset: { "services.resume.loginTokens": 1 } });                  // 2058
    if (user && user.loginIdentities) {                                                                                // 2060
      user.loginIdentities.forEach(function (identity) {                                                               // 2061
        Meteor.users.update({ _id: identity.id }, { $unset: { "services.resume.loginTokens": 1 } });                   // 2062
      });                                                                                                              // 2063
    }                                                                                                                  // 2064
  },                                                                                                                   // 2065
  unsuspendAccount: function unsuspendAccount(userId) {                                                                // 2067
    var _this7 = this;                                                                                                 // 2067
                                                                                                                       //
    check(userId, String);                                                                                             // 2068
                                                                                                                       //
    var user = this.collections.users.findOne({ _id: userId });                                                        // 2070
    this.collections.users.update({ _id: userId }, { $unset: { suspended: 1 } });                                      // 2071
    this.collections.grains.update({ userId: userId }, { $unset: { suspended: 1 } }, { multi: true });                 // 2072
                                                                                                                       //
    user.loginIdentities.forEach(function (identity) {                                                                 // 2074
      _this7.unsuspendIdentity(identity.id);                                                                           // 2075
    });                                                                                                                // 2076
                                                                                                                       //
    user.nonloginIdentities.forEach(function (identity) {                                                              // 2078
      _this7.unsuspendIdentity(identity.id);                                                                           // 2079
    });                                                                                                                // 2080
  },                                                                                                                   // 2081
  deletePendingAccounts: function deletePendingAccounts(deletionCoolingOffTime, backend, cb) {                         // 2083
    var _this8 = this;                                                                                                 // 2083
                                                                                                                       //
    check(deletionCoolingOffTime, Number);                                                                             // 2084
                                                                                                                       //
    var queryDate = new Date(Date.now() - deletionCoolingOffTime);                                                     // 2086
    this.collections.users.find({                                                                                      // 2087
      "suspended.willDelete": true,                                                                                    // 2088
      "suspended.timestamp": { $lt: queryDate }                                                                        // 2089
    }).forEach(function (user) {                                                                                       // 2087
      if (cb) cb(_this8, user);                                                                                        // 2091
      _this8.deleteAccount(user._id, backend);                                                                         // 2092
    });                                                                                                                // 2093
  },                                                                                                                   // 2094
                                                                                                                       //
                                                                                                                       //
  hostIsStandalone: function hostIsStandalone(hostname) {                                                              // 2096
    check(hostname, String);                                                                                           // 2097
                                                                                                                       //
    return !!this.collections.standaloneDomains.findOne({ _id: hostname });                                            // 2099
  }                                                                                                                    // 2100
});                                                                                                                    // 1179
                                                                                                                       //
SandstormDb.escapeMongoKey = function (key) {                                                                          // 2103
  // This incredibly poor mechanism for escaping Mongo keys is recommended by the Mongo docs here:                     //
  //   https://docs.mongodb.org/manual/faq/developers/#dollar-sign-operator-escaping                                   //
  // and seems to be a de facto standard, for example:                                                                 //
  //   https://www.npmjs.com/package/mongo-key-escape                                                                  //
  return key.replace(".", "．").replace("$", "＄");                                                                      // 2108
};                                                                                                                     // 2109
                                                                                                                       //
var appNameFromPackage = function appNameFromPackage(packageObj) {                                                     // 2111
  // This function takes a Package object from Mongo and returns an                                                    //
  // app title.                                                                                                        //
  var manifest = packageObj.manifest;                                                                                  // 2114
  if (!manifest) return packageObj.appId || packageObj._id || "unknown";                                               // 2115
  var action = manifest.actions[0];                                                                                    // 2116
  appName = manifest.appTitle && manifest.appTitle.defaultText || appNameFromActionName(action.title.defaultText);     // 2117
  return appName;                                                                                                      // 2119
};                                                                                                                     // 2120
                                                                                                                       //
var appNameFromActionName = function appNameFromActionName(name) {                                                     // 2122
  // Hack: Historically we only had action titles, like "New Etherpad Document", not app                               //
  //   titles. But for this UI we want app titles. As a transitionary measure, try to                                  //
  //   derive the app title from the action title.                                                                     //
  // TODO(cleanup): Get rid of this once apps have real titles.                                                        //
  if (!name) {                                                                                                         // 2127
    return "(unnamed)";                                                                                                // 2128
  }                                                                                                                    // 2129
                                                                                                                       //
  if (name.lastIndexOf("New ", 0) === 0) {                                                                             // 2131
    name = name.slice(4);                                                                                              // 2132
  }                                                                                                                    // 2133
                                                                                                                       //
  if (name.lastIndexOf("Hacker CMS", 0) === 0) {                                                                       // 2135
    name = "Hacker CMS";                                                                                               // 2136
  } else {                                                                                                             // 2137
    var space = name.indexOf(" ");                                                                                     // 2138
    if (space > 0) {                                                                                                   // 2139
      name = name.slice(0, space);                                                                                     // 2140
    }                                                                                                                  // 2141
  }                                                                                                                    // 2142
                                                                                                                       //
  return name;                                                                                                         // 2144
};                                                                                                                     // 2145
                                                                                                                       //
var appShortDescriptionFromPackage = function appShortDescriptionFromPackage(pkg) {                                    // 2147
  return pkg && pkg.manifest && pkg.manifest.metadata && pkg.manifest.metadata.shortDescription && pkg.manifest.metadata.shortDescription.defaultText;
};                                                                                                                     // 2151
                                                                                                                       //
var nounPhraseForActionAndAppTitle = function nounPhraseForActionAndAppTitle(action, appTitle) {                       // 2153
  // A hack to deal with legacy apps not including fields in their manifests.                                          //
  // I look forward to the day I can remove most of this code.                                                         //
  // Attempt to figure out the appropriate noun that this action will create.                                          //
  // Use an explicit noun phrase is one is available.  Apps should add these in the future.                            //
  if (action.nounPhrase) return action.nounPhrase.defaultText;                                                         // 2158
  // Otherwise, try to guess one from the structure of the action title field                                          //
  if (action.title && action.title.defaultText) {                                                                      // 2160
    var text = action.title.defaultText;                                                                               // 2161
    // Strip a leading "New "                                                                                          //
    if (text.lastIndexOf("New ", 0) === 0) {                                                                           // 2163
      var candidate = text.slice(4);                                                                                   // 2164
      // Strip a leading appname too, if provided                                                                      //
      if (candidate.lastIndexOf(appTitle, 0) === 0) {                                                                  // 2166
        var newCandidate = candidate.slice(appTitle.length);                                                           // 2167
        // Unless that leaves you with no noun, in which case, use "grain"                                             //
        if (newCandidate.length > 0) {                                                                                 // 2169
          return newCandidate.toLowerCase();                                                                           // 2170
        } else {                                                                                                       // 2171
          return "grain";                                                                                              // 2172
        }                                                                                                              // 2173
      }                                                                                                                // 2174
                                                                                                                       //
      return candidate.toLowerCase();                                                                                  // 2176
    }                                                                                                                  // 2177
    // Some other verb phrase was given.  Just use it verbatim, and hope the app author updates                        //
    // the package soon.                                                                                               //
    return text;                                                                                                       // 2180
  } else {                                                                                                             // 2181
    return "grain";                                                                                                    // 2182
  }                                                                                                                    // 2183
};                                                                                                                     // 2184
                                                                                                                       //
// Static methods on SandstormDb that don't need an instance.                                                          //
// Largely things that deal with backwards-compatibility.                                                              //
_.extend(SandstormDb, {                                                                                                // 2188
  appNameFromActionName: appNameFromActionName,                                                                        // 2189
  appNameFromPackage: appNameFromPackage,                                                                              // 2190
  appShortDescriptionFromPackage: appShortDescriptionFromPackage,                                                      // 2191
  nounPhraseForActionAndAppTitle: nounPhraseForActionAndAppTitle                                                       // 2192
});                                                                                                                    // 2188
                                                                                                                       //
if (Meteor.isServer) {                                                                                                 // 2195
  (function () {                                                                                                       // 2195
    var Crypto = Npm.require("crypto");                                                                                // 2196
    var ContentType = Npm.require("content-type");                                                                     // 2197
    var Zlib = Npm.require("zlib");                                                                                    // 2198
    var Url = Npm.require("url");                                                                                      // 2199
                                                                                                                       //
    var replicaNumber = Meteor.settings.replicaNumber || 0;                                                            // 2201
                                                                                                                       //
    var computeStagger = function computeStagger(n) {                                                                  // 2203
      // Compute a fraction in the range [0, 1) such that, for any natural number k, the values                        //
      // of computeStagger(n) for all n in [1, 2^k) are uniformly distributed between 0 and 1.                         //
      // The sequence looks like:                                                                                      //
      //   0, 1/2, 1/4, 3/4, 1/8, 3/8, 5/8, 7/8, 1/16, ...                                                             //
      //                                                                                                               //
      // We use this to determine how we'll stagger periodic events performed by this replica.                         //
      // Notice that this allows us to compute a stagger which is independent of the number of                         //
      // front-end replicas present; we can add more replicas to the end without affecting how the                     //
      // earlier ones schedule their events.                                                                           //
      var denom = 1;                                                                                                   // 2213
      while (denom <= n) {                                                                                             // 2214
        denom <<= 1;                                                                                                   // 2214
      }var num = n * 2 - denom + 1;                                                                                    // 2214
      return num / denom;                                                                                              // 2216
    };                                                                                                                 // 2217
                                                                                                                       //
    var stagger = computeStagger(replicaNumber);                                                                       // 2219
                                                                                                                       //
    SandstormDb.periodicCleanup = function (intervalMs, callback) {                                                    // 2221
      // Register a database cleanup function than should run periodically, roughly once every                         //
      // interval of the given length.                                                                                 //
      //                                                                                                               //
      // In a blackrock deployment with multiple front-ends, the frequency of the cleanup will be                      //
      // scaled appropriately on the assumption that more data is being generated demanding more                       //
      // frequent cleanups.                                                                                            //
                                                                                                                       //
      check(intervalMs, Number);                                                                                       // 2229
      check(callback, Function);                                                                                       // 2230
                                                                                                                       //
      if (intervalMs < 120000) {                                                                                       // 2232
        throw new Error("less than 2-minute cleanup interval seems too fast; " + "are you using the right units?");    // 2233
      }                                                                                                                // 2235
                                                                                                                       //
      // Schedule first cleanup to happen at the next intervalMs interval from the epoch, so that                      //
      // the schedule is independent of the exact startup time.                                                        //
      var first = intervalMs - Date.now() % intervalMs;                                                                // 2239
                                                                                                                       //
      // Stagger cleanups across replicas so that we don't have all replicas trying to clean the                       //
      // same data at the same time.                                                                                   //
      first += Math.floor(intervalMs * computeStagger(replicaNumber));                                                 // 2243
                                                                                                                       //
      // If the stagger put us more than an interval away from now, back up.                                           //
      if (first > intervalMs) first -= intervalMs;                                                                     // 2246
                                                                                                                       //
      Meteor.setTimeout(function () {                                                                                  // 2248
        callback();                                                                                                    // 2249
        Meteor.setInterval(callback, intervalMs);                                                                      // 2250
      }, first);                                                                                                       // 2251
    };                                                                                                                 // 2252
                                                                                                                       //
    // TODO(cleanup): Node 0.12 has a `gzipSync` but 0.10 (which Meteor still uses) does not.                          //
    var gzipSync = Meteor.wrapAsync(Zlib.gzip, Zlib);                                                                  // 2255
                                                                                                                       //
    var BufferSmallerThan = function BufferSmallerThan(limit) {                                                        // 2257
      return Match.Where(function (buf) {                                                                              // 2258
        check(buf, Buffer);                                                                                            // 2259
        return buf.length < limit;                                                                                     // 2260
      });                                                                                                              // 2261
    };                                                                                                                 // 2262
                                                                                                                       //
    var DatabaseId = Match.Where(function (s) {                                                                        // 2264
      check(s, String);                                                                                                // 2265
      return !!s.match(/^[a-zA-Z0-9_]+$/);                                                                             // 2266
    });                                                                                                                // 2267
                                                                                                                       //
    SandstormDb.prototype.addStaticAsset = function (metadata, content) {                                              // 2269
      // Add a new static asset to the database. If `content` is a string rather than a buffer, it                     //
      // will be automatically gzipped before storage; do not specify metadata.encoding in this case.                  //
                                                                                                                       //
      if (typeof content === "string" && !metadata.encoding) {                                                         // 2273
        content = gzipSync(new Buffer(content, "utf8"));                                                               // 2274
        metadata.encoding = "gzip";                                                                                    // 2275
      }                                                                                                                // 2276
                                                                                                                       //
      check(metadata, {                                                                                                // 2278
        mimeType: String,                                                                                              // 2279
        encoding: Match.Optional("gzip")                                                                               // 2280
      });                                                                                                              // 2278
      check(content, BufferSmallerThan(1 << 20));                                                                      // 2282
                                                                                                                       //
      // Validate content type.                                                                                        //
      metadata.mimeType = ContentType.format(ContentType.parse(metadata.mimeType));                                    // 2285
                                                                                                                       //
      var hasher = Crypto.createHash("sha256");                                                                        // 2287
      hasher.update(metadata.mimeType + "\n" + metadata.encoding + "\n", "utf8");                                      // 2288
      hasher.update(content);                                                                                          // 2289
      var hash = hasher.digest("base64");                                                                              // 2290
                                                                                                                       //
      var result = this.collections.staticAssets.findAndModify({                                                       // 2292
        query: { hash: hash, refcount: { $gte: 1 } },                                                                  // 2293
        update: { $inc: { refcount: 1 } },                                                                             // 2294
        fields: { _id: 1, refcount: 1 }                                                                                // 2295
      });                                                                                                              // 2292
                                                                                                                       //
      if (!result.ok) {                                                                                                // 2298
        throw new Error("Couldn't increment refcount of asset with hash " + hash);                                     // 2299
      }                                                                                                                // 2300
                                                                                                                       //
      var existing = result.value;                                                                                     // 2302
      if (existing) {                                                                                                  // 2303
        return existing._id;                                                                                           // 2304
      }                                                                                                                // 2305
                                                                                                                       //
      return this.collections.staticAssets.insert(_.extend({                                                           // 2307
        hash: hash,                                                                                                    // 2308
        content: content,                                                                                              // 2309
        refcount: 1                                                                                                    // 2310
      }, metadata));                                                                                                   // 2307
    };                                                                                                                 // 2312
                                                                                                                       //
    SandstormDb.prototype.refStaticAsset = function (id) {                                                             // 2314
      // Increment the refcount on an existing static asset. Returns the asset on success.                             //
      // If the asset does not exist, returns a falsey value.                                                          //
      //                                                                                                               //
      // You must call this BEFORE adding the new reference to the DB, in case of failure between                      //
      // the two calls. (This way, the failure case is a storage leak, which is probably not a big                     //
      // deal and can be fixed by GC, rather than a mysteriously missing asset.)                                       //
                                                                                                                       //
      check(id, String);                                                                                               // 2322
                                                                                                                       //
      var result = this.collections.staticAssets.findAndModify({                                                       // 2324
        query: { hash: hash },                                                                                         // 2325
        update: { $inc: { refcount: 1 } },                                                                             // 2326
        fields: { _id: 1, content: 1, mimeType: 1 }                                                                    // 2327
      });                                                                                                              // 2324
                                                                                                                       //
      if (!result.ok) {                                                                                                // 2330
        throw new Error("Couldn't increment refcount of asset with hash " + hash);                                     // 2331
      }                                                                                                                // 2332
                                                                                                                       //
      var existing = result.value;                                                                                     // 2334
      return existing;                                                                                                 // 2335
    };                                                                                                                 // 2336
                                                                                                                       //
    SandstormDb.prototype.unrefStaticAsset = function (id) {                                                           // 2338
      // Decrement refcount on a static asset and delete if it has reached zero.                                       //
      //                                                                                                               //
      // You must call this AFTER removing the reference from the DB, in case of failure between                       //
      // the two calls. (This way, the failure case is a storage leak, which is probably not a big                     //
      // deal and can be fixed by GC, rather than a mysteriously missing asset.)                                       //
                                                                                                                       //
      check(id, String);                                                                                               // 2345
                                                                                                                       //
      var result = this.collections.staticAssets.findAndModify({                                                       // 2347
        query: { _id: id },                                                                                            // 2348
        update: { $inc: { refcount: -1 } },                                                                            // 2349
        fields: { _id: 1, refcount: 1 },                                                                               // 2350
        "new": true                                                                                                    // 2351
      });                                                                                                              // 2347
                                                                                                                       //
      if (!result.ok) {                                                                                                // 2354
        throw new Error("Couldn't unref static asset " + id);                                                          // 2355
      }                                                                                                                // 2356
                                                                                                                       //
      var existing = result.value;                                                                                     // 2358
      if (!existing) {                                                                                                 // 2359
        console.error(new Error("unrefStaticAsset() called on asset that doesn't exist").stack);                       // 2360
      } else if (existing.refcount <= 0) {                                                                             // 2361
        this.collections.staticAssets.remove({ _id: existing._id });                                                   // 2362
      }                                                                                                                // 2363
    };                                                                                                                 // 2364
                                                                                                                       //
    SandstormDb.prototype.getStaticAsset = function (id) {                                                             // 2366
      // Get a static asset's mimeType, encoding, and raw content.                                                     //
                                                                                                                       //
      check(id, String);                                                                                               // 2369
                                                                                                                       //
      var asset = this.collections.staticAssets.findOne(id, { fields: { _id: 0, mimeType: 1, encoding: 1, content: 1 } });
      if (asset) {                                                                                                     // 2372
        // TODO(perf): Mongo converts buffers to something else. Figure out a way to avoid a copy                      //
        //   here.                                                                                                     //
        asset.content = new Buffer(asset.content);                                                                     // 2375
      }                                                                                                                // 2376
                                                                                                                       //
      return asset;                                                                                                    // 2378
    };                                                                                                                 // 2379
                                                                                                                       //
    SandstormDb.prototype.newAssetUpload = function (purpose) {                                                        // 2381
      check(purpose, Match.OneOf({ profilePicture: { userId: DatabaseId, identityId: DatabaseId } }, { loginLogo: {} }));
                                                                                                                       //
      return this.collections.assetUploadTokens.insert({                                                               // 2387
        purpose: purpose,                                                                                              // 2388
        expires: new Date(Date.now() + 300000) });                                                                     // 2389
    };                                                                                                                 // 2391
                                                                                                                       //
    // in 5 minutes                                                                                                    //
    SandstormDb.prototype.fulfillAssetUpload = function (id) {                                                         // 2393
      // Indicates that the given asset upload has completed. It will be removed and its purpose                       //
      // returned. If no matching upload exists, returns undefined.                                                    //
                                                                                                                       //
      check(id, String);                                                                                               // 2397
                                                                                                                       //
      var result = this.collections.assetUploadTokens.findAndModify({                                                  // 2399
        query: { _id: id },                                                                                            // 2400
        remove: true                                                                                                   // 2401
      });                                                                                                              // 2399
                                                                                                                       //
      if (!result.ok) {                                                                                                // 2404
        throw new Error("Failed to remove asset upload token");                                                        // 2405
      }                                                                                                                // 2406
                                                                                                                       //
      var upload = result.value;                                                                                       // 2408
                                                                                                                       //
      if (upload.expires.valueOf() < Date.now()) {                                                                     // 2410
        return undefined; // already expired                                                                           // 2411
      } else {                                                                                                         // 2412
          return upload.purpose;                                                                                       // 2413
        }                                                                                                              // 2414
    };                                                                                                                 // 2415
                                                                                                                       //
    SandstormDb.prototype.cleanupExpiredAssetUploads = function () {                                                   // 2417
      this.collections.assetUploadTokens.remove({ expires: { $lt: Date.now() } });                                     // 2418
    };                                                                                                                 // 2419
                                                                                                                       //
    // TODO(cleanup): lift this out of the package so it can share with the ones in async-helpers.js                   //
    var Future = Npm.require("fibers/future");                                                                         // 2422
    var promiseToFuture = function promiseToFuture(promise) {                                                          // 2423
      var result = new Future();                                                                                       // 2424
      promise.then(result["return"].bind(result), result["throw"].bind(result));                                       // 2425
      return result;                                                                                                   // 2426
    };                                                                                                                 // 2427
                                                                                                                       //
    var waitPromise = function waitPromise(promise) {                                                                  // 2429
      return promiseToFuture(promise).wait();                                                                          // 2430
    };                                                                                                                 // 2431
                                                                                                                       //
    SandstormDb.prototype.deleteGrains = function (query, backend, type) {                                             // 2433
      var _this9 = this;                                                                                               // 2433
                                                                                                                       //
      // Returns the number of grains deleted.                                                                         //
                                                                                                                       //
      check(type, Match.OneOf("grain", "demoGrain"));                                                                  // 2436
                                                                                                                       //
      var numDeleted = 0;                                                                                              // 2438
      this.collections.grains.find(query).forEach(function (grain) {                                                   // 2439
        var user = Meteor.users.findOne(grain.userId);                                                                 // 2440
                                                                                                                       //
        waitPromise(backend.deleteGrain(grain._id, grain.userId));                                                     // 2442
        numDeleted += _this9.collections.grains.remove({ _id: grain._id });                                            // 2443
        _this9.removeApiTokens({                                                                                       // 2444
          grainId: grain._id,                                                                                          // 2445
          $or: [{ owner: { $exists: false } }, { owner: { webkey: null } }]                                            // 2446
        });                                                                                                            // 2444
                                                                                                                       //
        _this9.removeApiTokens({ "owner.grain.grainId": grain._id });                                                  // 2452
                                                                                                                       //
        _this9.collections.activitySubscriptions.remove({ grainId: grain._id });                                       // 2454
                                                                                                                       //
        if (grain.lastUsed) {                                                                                          // 2456
          var record = {                                                                                               // 2457
            type: "grain", // Demo grains can never get here!                                                          // 2458
            lastActive: grain.lastUsed,                                                                                // 2459
            appId: grain.appId                                                                                         // 2460
          };                                                                                                           // 2457
          if (user && user.experiments) {                                                                              // 2462
            record.experiments = user.experiments;                                                                     // 2463
          }                                                                                                            // 2464
          _this9.collections.deleteStats.insert(record);                                                               // 2465
        }                                                                                                              // 2466
                                                                                                                       //
        _this9.deleteUnusedPackages(grain.appId);                                                                      // 2468
                                                                                                                       //
        if (grain.size) {                                                                                              // 2470
          Meteor.users.update(grain.userId, { $inc: { storageUsage: -grain.size } });                                  // 2471
        }                                                                                                              // 2472
      });                                                                                                              // 2473
      return numDeleted;                                                                                               // 2474
    };                                                                                                                 // 2475
                                                                                                                       //
    SandstormDb.prototype.userGrainTitle = function (grainId, accountId, identityId) {                                 // 2477
      check(grainId, String);                                                                                          // 2478
      check(accountId, Match.OneOf(String, undefined, null));                                                          // 2479
      check(identityId, String);                                                                                       // 2480
                                                                                                                       //
      var grain = this.getGrain(grainId);                                                                              // 2482
      if (!grain) {                                                                                                    // 2483
        throw new Error("called userGrainTitle() for a grain that doesn't exist");                                     // 2484
      }                                                                                                                // 2485
                                                                                                                       //
      var title = grain.title;                                                                                         // 2487
      if (grain.userId !== accountId) {                                                                                // 2488
        var sharerToken = this.collections.apiTokens.findOne({                                                         // 2489
          grainId: grainId,                                                                                            // 2490
          "owner.user.identityId": identityId                                                                          // 2491
        }, {                                                                                                           // 2489
          sort: {                                                                                                      // 2493
            lastUsed: -1                                                                                               // 2494
          }                                                                                                            // 2493
        });                                                                                                            // 2492
        if (sharerToken) {                                                                                             // 2497
          title = sharerToken.owner.user.title;                                                                        // 2498
        } else {                                                                                                       // 2499
          title = "shared grain";                                                                                      // 2500
        }                                                                                                              // 2501
      }                                                                                                                // 2502
                                                                                                                       //
      return title;                                                                                                    // 2504
    };                                                                                                                 // 2505
                                                                                                                       //
    var packageCache = {};                                                                                             // 2507
    // Package info is immutable. Let's cache to save on mongo queries.                                                //
                                                                                                                       //
    SandstormDb.prototype.getPackage = function (packageId) {                                                          // 2510
      // Get the given package record. Since package info is immutable, cache the data in the server                   //
      // to reduce mongo query overhead, since it turns out we have to fetch specific packages a                       //
      // lot.                                                                                                          //
                                                                                                                       //
      if (packageId in packageCache) {                                                                                 // 2515
        return packageCache[packageId];                                                                                // 2516
      }                                                                                                                // 2517
                                                                                                                       //
      var pkg = this.collections.packages.findOne(packageId);                                                          // 2519
      if (pkg && pkg.status === "ready") {                                                                             // 2520
        packageCache[packageId] = pkg;                                                                                 // 2521
      }                                                                                                                // 2522
                                                                                                                       //
      return pkg;                                                                                                      // 2524
    };                                                                                                                 // 2525
                                                                                                                       //
    SandstormDb.prototype.deleteUnusedPackages = function (appId) {                                                    // 2527
      var _this10 = this;                                                                                              // 2527
                                                                                                                       //
      check(appId, String);                                                                                            // 2528
      this.collections.packages.find({ appId: appId }).forEach(function (pkg) {                                        // 2529
        // Mark package for possible deletion;                                                                         //
        _this10.collections.packages.update({ _id: pkg._id, status: "ready" }, { $set: { shouldCleanup: true } });     // 2531
      });                                                                                                              // 2532
    };                                                                                                                 // 2533
                                                                                                                       //
    SandstormDb.prototype.sendAppUpdateNotifications = function (appId, packageId, name, versionNumber, marketingVersion) {
      var _this11 = this;                                                                                              // 2536
                                                                                                                       //
      var actions = this.collections.userActions.find({ appId: appId, appVersion: { $lt: versionNumber } }, { fields: { userId: 1 } });
      actions.forEach(function (action) {                                                                              // 2539
        var userId = action.userId;                                                                                    // 2540
        var updater = {                                                                                                // 2541
          timestamp: new Date(),                                                                                       // 2542
          isUnread: true                                                                                               // 2543
        };                                                                                                             // 2541
        var inserter = _.extend({ userId: userId, appUpdates: {} }, updater);                                          // 2545
                                                                                                                       //
        // Set only the appId that we care about. Use mongo's dot notation to specify only a single                    //
        // field inside of an object to update                                                                         //
        inserter.appUpdates[appId] = updater["appUpdates." + appId] = {                                                // 2549
          marketingVersion: marketingVersion,                                                                          // 2550
          packageId: packageId,                                                                                        // 2551
          name: name,                                                                                                  // 2552
          version: versionNumber                                                                                       // 2553
        };                                                                                                             // 2549
                                                                                                                       //
        // We unfortunately cannot upsert because upserts can only have field equality conditions in                   //
        // the query. If we try to upsert, Mongo complaints that "$exists" isn't valid to store.                       //
        if (_this11.collections.notifications.update({ userId: userId, appUpdates: { $exists: true } }, { $set: updater }) == 0) {
          // Update failed; try an insert instead.                                                                     //
          _this11.collections.notifications.insert(inserter);                                                          // 2562
        }                                                                                                              // 2563
      });                                                                                                              // 2564
                                                                                                                       //
      this.collections.appIndex.update({ _id: appId }, { $set: { hasSentNotifications: true } });                      // 2566
                                                                                                                       //
      // In the case where we replaced a previous notification and that was the only reference to the                  //
      // package, we need to clean it up                                                                               //
      this.deleteUnusedPackages(appId);                                                                                // 2570
    };                                                                                                                 // 2571
                                                                                                                       //
    SandstormDb.prototype.sendReferralProgramNotification = function (userId) {                                        // 2573
      this.collections.notifications.upsert({                                                                          // 2574
        userId: userId,                                                                                                // 2575
        referral: true                                                                                                 // 2576
      }, {                                                                                                             // 2574
        userId: userId,                                                                                                // 2578
        referral: true,                                                                                                // 2579
        timestamp: new Date(),                                                                                         // 2580
        isUnread: true                                                                                                 // 2581
      });                                                                                                              // 2577
    };                                                                                                                 // 2583
                                                                                                                       //
    SandstormDb.prototype.upgradeGrains = function (appId, version, packageId, backend) {                              // 2585
      check(appId, String);                                                                                            // 2586
      check(version, Match.Integer);                                                                                   // 2587
      check(packageId, String);                                                                                        // 2588
                                                                                                                       //
      var selector = {                                                                                                 // 2590
        userId: Meteor.userId(),                                                                                       // 2591
        appId: appId,                                                                                                  // 2592
        appVersion: { $lte: version },                                                                                 // 2593
        packageId: { $ne: packageId }                                                                                  // 2594
      };                                                                                                               // 2590
                                                                                                                       //
      this.collections.grains.find(selector).forEach(function (grain) {                                                // 2597
        backend.shutdownGrain(grain._id, grain.userId);                                                                // 2598
      });                                                                                                              // 2599
                                                                                                                       //
      this.collections.grains.update(selector, {                                                                       // 2601
        $set: { appVersion: version, packageId: packageId, packageSalt: Random.secret() }                              // 2602
      }, { multi: true });                                                                                             // 2601
    };                                                                                                                 // 2604
                                                                                                                       //
    SandstormDb.prototype.startInstall = function (packageId, url, retryFailed, isAutoUpdated) {                       // 2606
      // Mark package for possible installation.                                                                       //
                                                                                                                       //
      var fields = {                                                                                                   // 2609
        status: "download",                                                                                            // 2610
        progress: 0,                                                                                                   // 2611
        url: url,                                                                                                      // 2612
        isAutoUpdated: !!isAutoUpdated                                                                                 // 2613
      };                                                                                                               // 2609
                                                                                                                       //
      if (retryFailed) {                                                                                               // 2616
        this.collections.packages.update({ _id: packageId, status: "failed" }, { $set: fields });                      // 2617
      } else {                                                                                                         // 2618
        try {                                                                                                          // 2619
          fields._id = packageId;                                                                                      // 2620
          this.collections.packages.insert(fields);                                                                    // 2621
        } catch (err) {                                                                                                // 2622
          console.error("Simultaneous startInstall()s?", err.stack);                                                   // 2623
        }                                                                                                              // 2624
      }                                                                                                                // 2625
    };                                                                                                                 // 2626
                                                                                                                       //
    var ValidKeyFingerprint = Match.Where(function (keyFingerprint) {                                                  // 2628
      check(keyFingerprint, String);                                                                                   // 2629
      return !!keyFingerprint.match(/^[0-9A-F]{40}$/);                                                                 // 2630
    });                                                                                                                // 2631
                                                                                                                       //
    SandstormDb.prototype.updateKeybaseProfileAsync = function (keyFingerprint) {                                      // 2633
      var _this12 = this;                                                                                              // 2633
                                                                                                                       //
      // Asynchronously fetch the given Keybase profile and populate the KeybaseProfiles collection.                   //
                                                                                                                       //
      check(keyFingerprint, ValidKeyFingerprint);                                                                      // 2636
                                                                                                                       //
      console.log("fetching keybase", keyFingerprint);                                                                 // 2638
                                                                                                                       //
      HTTP.get("https://keybase.io/_/api/1.0/user/lookup.json?key_fingerprint=" + keyFingerprint + "&fields=basics,profile,proofs_summary", {
        timeout: 5000                                                                                                  // 2643
      }, function (err, keybaseResponse) {                                                                             // 2642
        if (err) {                                                                                                     // 2645
          console.log("keybase lookup error:", err.stack);                                                             // 2646
          return;                                                                                                      // 2647
        }                                                                                                              // 2648
                                                                                                                       //
        if (!keybaseResponse.data) {                                                                                   // 2650
          console.log("keybase didn't return JSON? Headers:", keybaseResponse.headers);                                // 2651
          return;                                                                                                      // 2652
        }                                                                                                              // 2653
                                                                                                                       //
        var profile = (keybaseResponse.data.them || [])[0];                                                            // 2655
                                                                                                                       //
        if (profile) {                                                                                                 // 2657
          // jscs:disable requireCamelCaseOrUpperCaseIdentifiers                                                       //
          var record = {                                                                                               // 2659
            displayName: (profile.profile || {}).full_name,                                                            // 2660
            handle: (profile.basics || {}).username,                                                                   // 2661
            proofs: (profile.proofs_summary || {}).all || []                                                           // 2662
          };                                                                                                           // 2659
          // jscs:enable requireCamelCaseOrUpperCaseIdentifiers                                                        //
                                                                                                                       //
          record.proofs.forEach(function (proof) {                                                                     // 2666
            // Remove potentially Mongo-incompatible stuff. (Currently Keybase returns nothing that                    //
            // this would filter.)                                                                                     //
            for (var field in proof) {                                                                                 // 2669
              // Don't allow field names containing '.' or '$'. Also don't allow sub-objects mainly                    //
              // because I'm too lazy to check the field names recursively (and Keybase doesn't                        //
              // return any objects anyway).                                                                           //
              if (field.match(/[.$]/) || _typeof(proof[field]) === "object") {                                         // 2673
                delete proof[field];                                                                                   // 2674
              }                                                                                                        // 2675
            }                                                                                                          // 2676
                                                                                                                       //
            // Indicate not verified.                                                                                  //
            // TODO(security): Asynchronously verify proofs. Presumably we can borrow code from the                    //
            //   Keybase node-based CLI.                                                                               //
            proof.status = "unverified";                                                                               // 2681
          });                                                                                                          // 2682
                                                                                                                       //
          _this12.collections.keybaseProfiles.update(keyFingerprint, { $set: record }, { upsert: true });              // 2684
        } else {                                                                                                       // 2685
          // Keybase reports no match, so remove what we know of this user. We don't want to remove                    //
          // the item entirely from the cache as this will cause us to repeatedly re-fetch the data                    //
          // from Keybase.                                                                                             //
          //                                                                                                           //
          // TODO(someday): We could perhaps keep the proofs if we can still verify them directly,                     //
          //   but at present we don't have the ability to verify proofs.                                              //
          _this12.collections.keybaseProfiles.update(keyFingerprint, { $unset: { displayName: "", handle: "", proofs: "" } }, { upsert: true });
        }                                                                                                              // 2694
      });                                                                                                              // 2695
    };                                                                                                                 // 2696
                                                                                                                       //
    SandstormDb.prototype.deleteUnusedAccount = function (backend, identityId) {                                       // 2698
      // If there is an *unused* account that has `identityId` as a login identity, deletes it.                        //
                                                                                                                       //
      check(identityId, String);                                                                                       // 2701
      var account = this.collections.users.findOne({ "loginIdentities.id": identityId });                              // 2702
      if (account && account.loginIdentities.length == 1 && account.nonloginIdentities.length == 0 && !this.collections.grains.findOne({ userId: account._id }) && !this.collections.apiTokens.findOne({ accountId: account._id }) && (!account.plan || account.plan === "free") && !(account.payments && account.payments.id) && !this.collections.contacts.findOne({ ownerId: account._id })) {
        this.collections.users.remove({ _id: account._id });                                                           // 2711
        backend.deleteUser(account._id);                                                                               // 2712
      }                                                                                                                // 2713
    };                                                                                                                 // 2714
                                                                                                                       //
    Meteor.publish("keybaseProfile", function (keyFingerprint) {                                                       // 2716
      check(keyFingerprint, ValidKeyFingerprint);                                                                      // 2717
      var db = this.connection.sandstormDb;                                                                            // 2718
                                                                                                                       //
      var cursor = db.collections.keybaseProfiles.find(keyFingerprint);                                                // 2720
      if (cursor.count() === 0) {                                                                                      // 2721
        // Fire off async update.                                                                                      //
        db.updateKeybaseProfileAsync(keyFingerprint);                                                                  // 2723
      }                                                                                                                // 2724
                                                                                                                       //
      return cursor;                                                                                                   // 2726
    });                                                                                                                // 2727
                                                                                                                       //
    Meteor.publish("appIndex", function (appId) {                                                                      // 2729
      check(appId, String);                                                                                            // 2730
      var db = this.connection.sandstormDb;                                                                            // 2731
      var cursor = db.collections.appIndex.find({ _id: appId });                                                       // 2732
      return cursor;                                                                                                   // 2733
    });                                                                                                                // 2734
                                                                                                                       //
    Meteor.publish("userPackages", function () {                                                                       // 2736
      var _this13 = this;                                                                                              // 2736
                                                                                                                       //
      // Users should be able to see packages that are either:                                                         //
      // 1. referenced by one of their userActions                                                                     //
      // 2. referenced by one of their grains                                                                          //
      var db = this.connection.sandstormDb;                                                                            // 2740
                                                                                                                       //
      // Note that package information, once it is in the database, is static. There's no need to                      //
      // reactively subscribe to changes to a package since they don't change. It's also unecessary                    //
      // to reactively remove a package from the client side when it is removed on the server, or                      //
      // when the client stops using it, because the worst case is the client has a small amount                       //
      // of extra info on a no-longer-used package held in memory until they refresh Sandstorm.                        //
      // So, we implement this as a cache: the first time each package ID shows up among the user's                    //
      // stuff, we push the package info to the client, and then we never update it.                                   //
      //                                                                                                               //
      // Alternatively, we could subscribe to each individual package query, but this would waste                      //
      // lots of server-side resources watching for events that will never happen or don't matter.                     //
      var hasPackage = {};                                                                                             // 2752
      var refPackage = function refPackage(packageId) {                                                                // 2753
        // Ignore dev apps.                                                                                            //
        if (packageId.lastIndexOf("dev-", 0) === 0) return;                                                            // 2755
                                                                                                                       //
        if (!hasPackage[packageId]) {                                                                                  // 2757
          hasPackage[packageId] = true;                                                                                // 2758
          var pkg = db.getPackage(packageId);                                                                          // 2759
          if (pkg) {                                                                                                   // 2760
            _this13.added("packages", packageId, pkg);                                                                 // 2761
          } else {                                                                                                     // 2762
            console.error("shouldn't happen: missing package referenced by user's stuff:", packageId);                 // 2763
          }                                                                                                            // 2765
        }                                                                                                              // 2766
      };                                                                                                               // 2767
                                                                                                                       //
      // package source 1: packages referred to by actions                                                             //
      var actions = db.userActions(this.userId);                                                                       // 2770
      var actionsHandle = actions.observe({                                                                            // 2771
        added: function added(newAction) {                                                                             // 2772
          refPackage(newAction.packageId);                                                                             // 2773
        },                                                                                                             // 2774
        changed: function changed(newAction, oldAction) {                                                              // 2776
          refPackage(newAction.packageId);                                                                             // 2777
        }                                                                                                              // 2778
      });                                                                                                              // 2771
                                                                                                                       //
      // package source 2: packages referred to by grains directly                                                     //
      var grains = db.userGrains(this.userId, { includeTrash: true });                                                 // 2782
      var grainsHandle = grains.observe({                                                                              // 2783
        added: function added(newGrain) {                                                                              // 2784
          // Watch out: DevApp grains can lack a packageId.                                                            //
          if (newGrain.packageId) {                                                                                    // 2786
            refPackage(newGrain.packageId);                                                                            // 2787
          }                                                                                                            // 2788
        },                                                                                                             // 2789
        changed: function changed(newGrain, oldGrain) {                                                                // 2791
          // Watch out: DevApp grains can lack a packageId.                                                            //
          if (newGrain.packageId) {                                                                                    // 2793
            refPackage(newGrain.packageId);                                                                            // 2794
          }                                                                                                            // 2795
        }                                                                                                              // 2796
      });                                                                                                              // 2783
                                                                                                                       //
      this.onStop(function () {                                                                                        // 2799
        actionsHandle.stop();                                                                                          // 2800
        grainsHandle.stop();                                                                                           // 2801
      });                                                                                                              // 2802
                                                                                                                       //
      this.ready();                                                                                                    // 2804
    });                                                                                                                // 2805
  })();                                                                                                                // 2195
}                                                                                                                      // 2806
                                                                                                                       //
var processRawFeatureKey = function processRawFeatureKey(featureKey, renewalProblem) {                                 // 2808
  // Maps the raw data of a signed feature key to the desired "effective" feature key we should use                    //
  // to govern high-level behavior.                                                                                    //
  var processedFeatureKey = _.clone(featureKey);                                                                       // 2811
                                                                                                                       //
  if (renewalProblem) {                                                                                                // 2813
    processedFeatureKey.renewalProblem = renewalProblem;                                                               // 2814
  }                                                                                                                    // 2815
                                                                                                                       //
  // Hook for future extensibility.                                                                                    //
  return processedFeatureKey;                                                                                          // 2818
};                                                                                                                     // 2819
                                                                                                                       //
if (Meteor.isServer) {                                                                                                 // 2821
  (function () {                                                                                                       // 2821
    var processFeatureKeyDoc = function processFeatureKeyDoc(doc) {                                                    // 2822
      if (!doc) return null;                                                                                           // 2823
      var buf = new Buffer(doc.value);                                                                                 // 2824
      // We use loadSignedFeatureKey from server/feature-key.js.  This should probably get refactored                  //
      // once we can use ES6 modules.                                                                                  //
      var rawFeatureKey = loadSignedFeatureKey(buf);                                                                   // 2827
      return processRawFeatureKey(rawFeatureKey, doc.renewalProblem);                                                  // 2828
    };                                                                                                                 // 2829
                                                                                                                       //
    SandstormDb.prototype.currentFeatureKey = function () {                                                            // 2831
      // Returns an object with all of the current signed feature key properties,                                      //
      // or null, if the feature key is missing or not correctly signed.                                               //
      var doc = this.collections.featureKey.findOne({ _id: "currentFeatureKey" });                                     // 2834
      return processFeatureKeyDoc(doc);                                                                                // 2835
    };                                                                                                                 // 2836
                                                                                                                       //
    SandstormDb.prototype.observeFeatureKey = function (callback) {                                                    // 2838
      // Calls `callback(currentFeatureKey())` whenever the feature key changes. Returns an observe                    //
      // handle (use .stop() to stop observing).                                                                       //
                                                                                                                       //
      return this.collections.featureKey.find({ _id: "currentFeatureKey" }).observe({                                  // 2842
        added: function added(doc) {                                                                                   // 2843
          callback(processFeatureKeyDoc(doc));                                                                         // 2844
        },                                                                                                             // 2845
        changed: function changed(newDoc, oldDoc) {                                                                    // 2847
          if (newDoc.value !== oldDoc.value) {                                                                         // 2848
            callback(processFeatureKeyDoc(newDoc));                                                                    // 2849
          }                                                                                                            // 2850
        },                                                                                                             // 2851
        removed: function removed() {                                                                                  // 2853
          callback(null);                                                                                              // 2854
        }                                                                                                              // 2855
      });                                                                                                              // 2842
    };                                                                                                                 // 2857
  })();                                                                                                                // 2821
} else {                                                                                                               // 2858
  SandstormDb.prototype.currentFeatureKey = function () {                                                              // 2859
    var featureKey = this.collections.featureKey.findOne({ _id: "currentFeatureKey" });                                // 2860
    return processRawFeatureKey(featureKey);                                                                           // 2861
  };                                                                                                                   // 2862
}                                                                                                                      // 2863
                                                                                                                       //
if (Meteor.isServer) {                                                                                                 // 2865
  SandstormDb.prototype.deleteIdentity = function (identityId) {                                                       // 2866
    check(identityId, String);                                                                                         // 2867
                                                                                                                       //
    this.removeApiTokens({ "owner.user.identityId": identityId });                                                     // 2869
    this.collections.contacts.remove({ identityId: identityId });                                                      // 2870
    Meteor.users.remove({ _id: identityId });                                                                          // 2871
  };                                                                                                                   // 2872
                                                                                                                       //
  SandstormDb.prototype.deleteAccount = function (userId, backend) {                                                   // 2874
    check(userId, String);                                                                                             // 2875
                                                                                                                       //
    var _this = this;                                                                                                  // 2877
    var user = Meteor.users.findOne({ _id: userId });                                                                  // 2878
    this.deleteGrains({ userId: userId }, backend, "grain");                                                           // 2879
    this.collections.userActions.remove({ userId: userId });                                                           // 2880
    this.collections.notifications.remove({ userId: userId });                                                         // 2881
    user.loginIdentities.forEach(function (identity) {                                                                 // 2882
      if (Meteor.users.find({ $or: [{ "loginIdentities.id": identity.id }, { "nonloginIdentities.id": identity.id }] }).count() === 1) {
        // If this is the only account with the identity, then delete it                                               //
        _this.deleteIdentity(identity.id);                                                                             // 2888
      }                                                                                                                // 2889
    });                                                                                                                // 2890
    user.nonloginIdentities.forEach(function (identity) {                                                              // 2891
      if (Meteor.users.find({ $or: [{ "loginIdentities.id": identity.id }, { "nonloginIdentities.id": identity.id }] }).count() === 1) {
        // If this is the only account with the identity, then delete it                                               //
        _this.deleteIdentity(identity.id);                                                                             // 2897
      }                                                                                                                // 2898
    });                                                                                                                // 2899
    this.collections.contacts.remove({ ownerId: userId });                                                             // 2900
    backend.deleteUser(userId);                                                                                        // 2901
    Meteor.users.remove({ _id: userId });                                                                              // 2902
  };                                                                                                                   // 2903
}                                                                                                                      // 2904
                                                                                                                       //
Meteor.methods({                                                                                                       // 2906
  addUserActions: function addUserActions(packageId) {                                                                 // 2907
    check(packageId, String);                                                                                          // 2908
    if (!this.userId || !Meteor.user().loginIdentities || !isSignedUpOrDemo()) {                                       // 2909
      throw new Meteor.Exception(403, "Must be logged in as a non-guest to add app actions.");                         // 2910
    }                                                                                                                  // 2911
                                                                                                                       //
    if (this.isSimulation) {                                                                                           // 2913
      // TODO(cleanup): Appdemo code relies on this being simulated client-side but we don't have                      //
      //   a proper DB object to use.                                                                                  //
      new SandstormDb().addUserActions(this.userId, packageId, true);                                                  // 2916
    } else {                                                                                                           // 2917
      this.connection.sandstormDb.addUserActions(this.userId, packageId);                                              // 2918
    }                                                                                                                  // 2919
  },                                                                                                                   // 2920
  removeUserAction: function removeUserAction(actionId) {                                                              // 2922
    check(actionId, String);                                                                                           // 2923
    if (this.isSimulation) {                                                                                           // 2924
      UserActions.remove({ _id: actionId });                                                                           // 2925
    } else {                                                                                                           // 2926
      if (this.userId) {                                                                                               // 2927
        var result = this.connection.sandstormDb.collections.userActions.findAndModify({                               // 2928
          query: { _id: actionId, userId: this.userId },                                                               // 2929
          remove: true                                                                                                 // 2930
        });                                                                                                            // 2928
                                                                                                                       //
        if (!result.ok) {                                                                                              // 2933
          throw new Error("Couldn't remove user action " + actionId);                                                  // 2934
        }                                                                                                              // 2935
                                                                                                                       //
        var action = result.value;                                                                                     // 2937
        if (action) {                                                                                                  // 2938
          this.connection.sandstormDb.deleteUnusedPackages(action.appId);                                              // 2939
        }                                                                                                              // 2940
      }                                                                                                                // 2941
    }                                                                                                                  // 2942
  }                                                                                                                    // 2943
});                                                                                                                    // 2906
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"profile.js":["babel-runtime/helpers/typeof",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/sandstorm-db/profile.js                                                                                    //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _typeof;module.import("babel-runtime/helpers/typeof",{"default":function(v){_typeof=v}});                          //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2015 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var makeIdenticon = void 0;                                                                                            // 17
var httpProtocol = void 0;                                                                                             // 18
                                                                                                                       //
if (Meteor.isServer) {                                                                                                 // 20
  SandstormDb.ensureSubscriberHasIdentity = function (publishHandler, identityId) {                                    // 21
    // Helper for publish functions that need to restrict access based on whether the subscriber                       //
    // has a given identity linked. Automatically stops the subscription if the user loses the                         //
    // identity. Returns a boolean indicating whether the user initially has the identity.                             //
                                                                                                                       //
    var userId = publishHandler.userId;                                                                                // 26
    if (userId === identityId) {                                                                                       // 27
      return true;                                                                                                     // 28
    } else {                                                                                                           // 29
      var _ret = function () {                                                                                         // 29
        var hasIdentityCursor = Meteor.users.find({                                                                    // 30
          $or: [{                                                                                                      // 31
            _id: userId,                                                                                               // 33
            "loginIdentities.id": identityId                                                                           // 34
          }, {                                                                                                         // 32
            _id: userId,                                                                                               // 37
            "nonloginIdentities.id": identityId                                                                        // 38
          }]                                                                                                           // 36
        });                                                                                                            // 30
        if (hasIdentityCursor.count() == 0) {                                                                          // 42
          publishHandler.stop();                                                                                       // 43
          return {                                                                                                     // 44
            v: false                                                                                                   // 44
          };                                                                                                           // 44
        }                                                                                                              // 45
                                                                                                                       //
        var handle = hasIdentityCursor.observe({ removed: function removed() {                                         // 47
            publishHandler.stop();                                                                                     // 47
          } });                                                                                                        // 47
                                                                                                                       //
        publishHandler.onStop(function () {                                                                            // 49
          handle.stop();                                                                                               // 49
        });                                                                                                            // 49
                                                                                                                       //
        return {                                                                                                       // 51
          v: true                                                                                                      // 51
        };                                                                                                             // 51
      }();                                                                                                             // 29
                                                                                                                       //
      if ((typeof _ret === "undefined" ? "undefined" : _typeof(_ret)) === "object") return _ret.v;                     // 29
    }                                                                                                                  // 52
  };                                                                                                                   // 53
                                                                                                                       //
  Meteor.publish("identityProfile", function (identityId) {                                                            // 55
    check(identityId, String);                                                                                         // 56
    if (!SandstormDb.ensureSubscriberHasIdentity(this, identityId)) return;                                            // 57
                                                                                                                       //
    return Meteor.users.find({ _id: identityId }, { fields: {                                                          // 59
        profile: 1,                                                                                                    // 61
        unverifiedEmail: 1,                                                                                            // 62
        expires: 1,                                                                                                    // 63
        createdAt: 1,                                                                                                  // 64
                                                                                                                       //
        "services.dev.name": 1,                                                                                        // 66
                                                                                                                       //
        "services.google.id": 1,                                                                                       // 68
        "services.google.email": 1,                                                                                    // 69
        "services.google.verified_email": 1,                                                                           // 70
        "services.google.name": 1,                                                                                     // 71
        "services.google.picture": 1,                                                                                  // 72
        "services.google.gender": 1,                                                                                   // 73
        "services.google.hd": 1,                                                                                       // 74
                                                                                                                       //
        "services.github.id": 1,                                                                                       // 76
        "services.github.email": 1,                                                                                    // 77
        "services.github.emails": 1,                                                                                   // 78
        "services.github.username": 1,                                                                                 // 79
                                                                                                                       //
        "services.email.email": 1,                                                                                     // 81
                                                                                                                       //
        "services.ldap.id": 1,                                                                                         // 83
        "services.ldap.username": 1,                                                                                   // 84
        "services.ldap.rawAttrs": 1,                                                                                   // 85
                                                                                                                       //
        "services.saml.id": 1,                                                                                         // 87
        "services.saml.email": 1,                                                                                      // 88
        "services.saml.displayName": 1                                                                                 // 89
      }                                                                                                                // 60
    });                                                                                                                // 60
  }), Meteor.publish("accountIdentities", function () {                                                                // 92
    // Maybe this should be folded into the "credentials" subscription?                                                //
                                                                                                                       //
    if (!this.userId) return [];                                                                                       // 97
                                                                                                                       //
    return Meteor.users.find({ _id: this.userId }, { fields: {                                                         // 99
        profile: 1,                                                                                                    // 102
        verifiedEmail: 1,                                                                                              // 103
        loginIdentities: 1,                                                                                            // 104
        nonloginIdentities: 1,                                                                                         // 105
        expires: 1,                                                                                                    // 106
        primaryEmail: 1                                                                                                // 107
      } });                                                                                                            // 101
  });                                                                                                                  // 109
                                                                                                                       //
  makeIdenticon = function makeIdenticon(id) {                                                                         // 111
    var hash = id.slice(0, 32);                                                                                        // 112
    return httpProtocol + "//" + makeWildcardHost("static") + "/identicon/" + hash + "?s=256";                         // 113
  };                                                                                                                   // 114
                                                                                                                       //
  var Url = Npm.require("url");                                                                                        // 116
  httpProtocol = Url.parse(process.env.ROOT_URL).protocol;                                                             // 117
} else {                                                                                                               // 118
  (function () {                                                                                                       // 118
    var identiconCache = {};                                                                                           // 119
                                                                                                                       //
    makeIdenticon = function makeIdenticon(id) {                                                                       // 121
      // Given a cryptographic hash as input, generate an identicon. We always use the user's                          //
      // identity ID as the input hash (the same thing passed to apps as the user ID).                                 //
                                                                                                                       //
      // Pass to identicon.js exactly the hash that we'd pass to apps as X-Sandstorm-User-Id, so                       //
      // that apps can themselves use identicon.js to produce consistent identicons. As it turns out                   //
      // identicon.js doesn't use the second half of the hash even if we provide it, but slice it                      //
      // anyway to be safe.                                                                                            //
      var hash = id.slice(0, 32);                                                                                      // 129
                                                                                                                       //
      if (hash in identiconCache) {                                                                                    // 131
        return identiconCache[hash];                                                                                   // 132
      }                                                                                                                // 133
                                                                                                                       //
      // Unfortunately, Github's algorithm uses MD5. Whatever, we don't expect these to be secure.                     //
      var data = new Identicon(hash, 512).toString();                                                                  // 136
      var result = "data:image/svg+xml," + encodeURIComponent(data);                                                   // 137
      identiconCache[hash] = result;                                                                                   // 138
      return result;                                                                                                   // 139
    };                                                                                                                 // 140
                                                                                                                       //
    httpProtocol = window.location.protocol;                                                                           // 142
  })();                                                                                                                // 118
}                                                                                                                      // 143
                                                                                                                       //
var GENDERS = { male: "male", female: "female", neutral: "neutral", robot: "robot" };                                  // 145
                                                                                                                       //
function staticAssetUrl(id, staticHost) {                                                                              // 147
  if (id) {                                                                                                            // 148
    return staticHost + "/" + id;                                                                                      // 149
  } else {                                                                                                             // 150
    return undefined;                                                                                                  // 151
  }                                                                                                                    // 152
}                                                                                                                      // 153
                                                                                                                       //
function filterHandle(handle) {                                                                                        // 155
  // Convert disallowed letters into underscores, but no more than one underscore in a row.                            //
  return handle && handle.toLowerCase().split(/[^a-z0-9_]+/g).join("_");                                               // 157
}                                                                                                                      // 158
                                                                                                                       //
function emailToHandle(email) {                                                                                        // 160
  // Turn an email address into a handle.                                                                              //
                                                                                                                       //
  if (!email) return undefined;                                                                                        // 163
                                                                                                                       //
  // Use the stuff before the @. Ignore stuff after '+' because it's commonly used for filters                         //
  // on the same account.                                                                                              //
  var parts = email.split("@");                                                                                        // 167
  var base = filterHandle(parts[0].split("+")[0]);                                                                     // 168
                                                                                                                       //
  var domain = (parts[1] || "").split(".");                                                                            // 170
  if (domain[domain.length - 1] === "name") {                                                                          // 171
    // Oh, a .name domain. Let's use                                                                                   //
    base = filterHandle(domain.slice(0, domain.length - 1).join("."));                                                 // 173
  } else if (_.contains(["me", "self", "contact", "admin", "administrator", "root", "info", "sandstorm", "sandstormio", "inbox", "indiegogo", "mail", "email"], base)) {
    // This is probably an address at a vanity domain. Use the domain itself as the handle.                            //
    base = filterHandle(domain[0]);                                                                                    // 181
  }                                                                                                                    // 182
                                                                                                                       //
  return filterHandle(base);                                                                                           // 184
}                                                                                                                      // 185
                                                                                                                       //
SandstormDb.fillInProfileDefaults = function (user) {                                                                  // 187
  var profile = user.profile;                                                                                          // 188
  if (profile.service === "github") {                                                                                  // 189
    profile.name = profile.name || user.services.github.username || "Name Unknown";                                    // 190
    profile.handle = profile.handle || filterHandle(user.services.github.username) || filterHandle(profile.name);      // 191
  } else if (profile.service === "google") {                                                                           // 193
    profile.name = profile.name || user.services.google.name || "Name Unknown";                                        // 194
    profile.handle = profile.handle || emailToHandle(user.services.google.email) || filterHandle(profile.name);        // 195
    profile.pronoun = profile.pronoun || GENDERS[user.services.google.gender] || "neutral";                            // 197
  } else if (profile.service === "email") {                                                                            // 198
    var email = user.services.email.email;                                                                             // 199
    profile.name = profile.name || emailToHandle(email);                                                               // 200
    profile.handle = profile.handle || emailToHandle(email);                                                           // 201
  } else if (profile.service === "dev") {                                                                              // 202
    var lowerCaseName = user.services.dev.name.split(" ")[0].toLowerCase();                                            // 203
    profile.name = profile.name || user.services.dev.name;                                                             // 204
    profile.handle = profile.handle || filterHandle(lowerCaseName);                                                    // 205
    profile.pronoun = profile.pronoun || (_.contains(["alice", "carol", "eve"], lowerCaseName) ? "female" : _.contains(["bob", "dave"], lowerCaseName) ? "male" : "neutral");
  } else if (profile.service === "demo") {                                                                             // 209
    profile.name = profile.name || "Demo User";                                                                        // 210
    profile.handle = profile.handle || "demo";                                                                         // 211
  } else if (profile.service === "ldap") {                                                                             // 212
    var setting = Settings.findOne({ _id: "ldapNameField" });                                                          // 213
    var key = setting ? setting.value : "";                                                                            // 214
    profile.handle = profile.handle || user.services.ldap.username;                                                    // 215
    profile.name = profile.name || user.services.ldap.rawAttrs[key] || profile.handle;                                 // 216
  } else if (profile.service === "saml") {                                                                             // 217
    profile.handle = profile.handle || emailToHandle(user.services.saml.email);                                        // 218
    profile.name = profile.name || user.services.saml.displayName || profile.handle;                                   // 219
  } else {                                                                                                             // 220
    throw new Error("unrecognized identity service: ", profile.service);                                               // 221
  }                                                                                                                    // 222
                                                                                                                       //
  profile.pronoun = profile.pronoun || "neutral";                                                                      // 224
};                                                                                                                     // 225
                                                                                                                       //
SandstormDb.fillInIntrinsicName = function (user) {                                                                    // 227
  var profile = user.profile;                                                                                          // 228
  if (profile.service === "github") {                                                                                  // 229
    profile.intrinsicName = user.services.github.username;                                                             // 230
  } else if (profile.service === "google") {                                                                           // 231
    profile.intrinsicName = user.services.google.name;                                                                 // 232
    user.privateIntrinsicName = user.services.google.email;                                                            // 233
  } else if (profile.service === "email") {                                                                            // 234
    profile.intrinsicName = user.services.email.email;                                                                 // 235
  } else if (profile.service === "dev") {                                                                              // 236
    profile.intrinsicName = user.services.dev.name;                                                                    // 237
  } else if (profile.service === "demo") {                                                                             // 238
    profile.intrinsicName = "demo on " + user.createdAt.toISOString().substring(0, 10);                                // 239
  } else if (profile.service === "ldap") {                                                                             // 240
    profile.intrinsicName = user.services.ldap.username;                                                               // 241
  } else if (profile.service === "saml") {                                                                             // 242
    profile.intrinsicName = user.services.saml.id;                                                                     // 243
  } else {                                                                                                             // 244
    throw new Error("unrecognized identity service: ", profile.service);                                               // 245
  }                                                                                                                    // 246
};                                                                                                                     // 247
                                                                                                                       //
SandstormDb.fillInLoginId = function (identity) {                                                                      // 249
  var service = identity.profile.service;                                                                              // 250
  identity.loginId = Accounts.identityServices[service].getLoginId(identity);                                          // 251
};                                                                                                                     // 252
                                                                                                                       //
SandstormDb.getVerifiedEmails = function (identity) {                                                                  // 254
  if (identity.services.google && identity.services.google.email && identity.services.google.verified_email) {         // 255
    // jscs:ignore requireCamelCaseOrUpperCaseIdentifiers                                                              //
    return [{ email: identity.services.google.email, primary: true }];                                                 // 257
  } else if (identity.services.email) {                                                                                // 258
    return [{ email: identity.services.email.email, primary: true }];                                                  // 259
  } else if (identity.services.github && identity.services.github.emails) {                                            // 260
    return _.chain(identity.services.github.emails).filter(function (email) {                                          // 261
      return email.verified;                                                                                           // 262
    }).map(function (email) {                                                                                          // 262
      return _.pick(email, "email", "primary");                                                                        // 263
    }).value();                                                                                                        // 263
  } else if (identity.services.ldap) {                                                                                 // 265
    // TODO(cleanup): don't create a new SandstormDb here, make this non-static                                        //
    var email = identity.services.ldap.rawAttrs[new SandstormDb().getLdapEmailField()];                                // 267
    if (email) {                                                                                                       // 268
      return [{ email: email, primary: true }];                                                                        // 269
    }                                                                                                                  // 270
  } else if (identity.services.saml && identity.services.saml.email) {                                                 // 271
    return [{ email: identity.services.saml.email, primary: true }];                                                   // 272
  }                                                                                                                    // 273
                                                                                                                       //
  return [];                                                                                                           // 275
};                                                                                                                     // 276
                                                                                                                       //
SandstormDb.prototype.findIdentitiesByEmail = function (email) {                                                       // 278
  // Returns an array of identities which have the given email address as one of their verified                        //
  // addresses.                                                                                                        //
                                                                                                                       //
  check(email, String);                                                                                                // 282
                                                                                                                       //
  // For LDAP, the field containing the e-mail address is configurable...                                              //
  var ldapQuery = {};                                                                                                  // 285
  ldapQuery["services.ldap.rawAttrs." + this.getLdapEmailField()] = email;                                             // 286
                                                                                                                       //
  return Meteor.users.find({ $or: [{ "services.google.email": email }, { "services.email.email": email }, { "services.github.emails.email": email }, ldapQuery, { "services.saml.email": email }] }).fetch().filter(function (identity) {
    // Verify that the email is verified, since our query doesn't technically do that.                                 //
    return !!_.findWhere(SandstormDb.getVerifiedEmails(identity), { email: email });                                   // 296
  });                                                                                                                  // 297
};                                                                                                                     // 298
                                                                                                                       //
SandstormDb.prototype.findAccountsByEmail = function (email) {                                                         // 300
  var identityIds = _.pluck(this.findIdentitiesByEmail(email), "_id");                                                 // 301
  return Meteor.users.find({ $or: [{ "loginIdentities.id": { $in: identityIds } }, { "nonloginIdentities.id": { $in: identityIds } }] }).fetch();
};                                                                                                                     // 306
                                                                                                                       //
SandstormDb.fillInPictureUrl = function (user) {                                                                       // 308
  var staticHost = httpProtocol + "//" + makeWildcardHost("static");                                                   // 309
  user.profile.pictureUrl = staticAssetUrl(user.profile.picture, staticHost) || makeIdenticon(user._id);               // 310
};                                                                                                                     // 312
                                                                                                                       //
SandstormDb.getUserIdentityIds = function (user) {                                                                     // 314
  // Given an account user object, returns an array containing the ID of each identity linked to the                   //
  // account. Always returns the most recently added login identity first.                                             //
  if (user && user.loginIdentities) {                                                                                  // 317
    return _.pluck(user.nonloginIdentities.concat(user.loginIdentities), "id").reverse();                              // 318
  } else {                                                                                                             // 319
    return [];                                                                                                         // 320
  }                                                                                                                    // 321
};                                                                                                                     // 322
                                                                                                                       //
SandstormDb.getUserEmails = function (user) {                                                                          // 324
  // Given a user object, returns an array containing all email addresses associated with that user.                   //
  // Each entry in the array is an object of the form:                                                                 //
  //     `{email: String, verified: Bool, primary: Optional(Bool)}`                                                    //
  //                                                                                                                   //
  // At most one entry in the result has `primary = true`.                                                             //
  //                                                                                                                   //
  // TODO(cleanup): This actually does need to query the database to fetch profile information                         //
  //   for linked identities, so it probably makes more sense for it to be a non-static method                         //
  //   on SandstormDb.                                                                                                 //
                                                                                                                       //
  var identityIds = SandstormDb.getUserIdentityIds(user);                                                              // 335
  var verifiedEmails = {};                                                                                             // 336
  var unverifiedEmails = {};                                                                                           // 337
                                                                                                                       //
  identityIds.forEach(function (id) {                                                                                  // 339
    var identity = Meteor.users.findOne({ _id: id });                                                                  // 340
    if (identity && identity.services) {                                                                               // 341
      SandstormDb.getVerifiedEmails(identity).forEach(function (verifiedEmail) {                                       // 342
        if (verifiedEmail) {                                                                                           // 343
          verifiedEmails[verifiedEmail.email] = true;                                                                  // 344
        }                                                                                                              // 345
      });                                                                                                              // 346
    }                                                                                                                  // 347
                                                                                                                       //
    if (identity && identity.unverifiedEmail) {                                                                        // 349
      unverifiedEmails[identity.unverifiedEmail] = true;                                                               // 350
    }                                                                                                                  // 351
  });                                                                                                                  // 352
                                                                                                                       //
  var result = [];                                                                                                     // 354
  _.keys(verifiedEmails).map(function (email) {                                                                        // 355
    result.push({ email: email,                                                                                        // 356
      verified: true,                                                                                                  // 357
      primary: email === user.primaryEmail });                                                                         // 358
  });                                                                                                                  // 359
                                                                                                                       //
  _.keys(unverifiedEmails).map(function (email) {                                                                      // 361
    if (!(email in verifiedEmails)) {                                                                                  // 362
      result.push({ email: email, verified: false });                                                                  // 362
    }                                                                                                                  // 362
  });                                                                                                                  // 363
                                                                                                                       //
  // If `user.primaryEmail` is not among the verified emails, mark the first as primary.                               //
  if (!(user.primaryEmail in verifiedEmails) && result.length > 0) {                                                   // 366
    result[0].primary = true;                                                                                          // 367
  }                                                                                                                    // 368
                                                                                                                       //
  return result;                                                                                                       // 370
};                                                                                                                     // 371
                                                                                                                       //
SandstormDb.prototype.addContact = function addContact(ownerId, identityId) {                                          // 373
  check(ownerId, String);                                                                                              // 374
  check(identityId, String);                                                                                           // 375
  var profile = this.getIdentity(identityId).profile;                                                                  // 376
  this.collections.contacts.upsert({ ownerId: ownerId, identityId: identityId }, {                                     // 377
    ownerId: ownerId,                                                                                                  // 378
    petname: profile && profile.name,                                                                                  // 379
    created: new Date(),                                                                                               // 380
    identityId: identityId                                                                                             // 381
  });                                                                                                                  // 377
};                                                                                                                     // 383
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}]}}}},{"extensions":[".js",".json"]});
require("./node_modules/meteor/sandstorm-db/db.js");
require("./node_modules/meteor/sandstorm-db/profile.js");

/* Exports */
if (typeof Package === 'undefined') Package = {};
(function (pkg, symbols) {
  for (var s in symbols)
    (s in pkg) || (pkg[s] = symbols[s]);
})(Package['sandstorm-db'] = {}, {
  SandstormDb: SandstormDb
});

})();

//# sourceMappingURL=sandstorm-db.js.map
